char __based (__segname("_CODE")) dos_errors[] =
{
  0x0C, // bad command -> general failure
  0x0B, // address mark not found -> read fault
  0x00, // write protect error
  0x08, // sector not found
  0x02, // disk reset failed -> device not ready
  0x02, // diskette changed or removed -> device not ready
  0x0C, // bad fixed disk parameter table -> general failure
  0x0C, // DMA overrun -> general failure
  0x0C, // DMA access over 64k boundary -> general failure
  0x08, // Bad fixed disk sector flag -> sector not found
  0x08, // bad fixed disk cylinder -> sector not found
  0x07, // unsupported track/invalid media -> unknown media type
};

unsigned char bios2doserror(unsigned char bios_error)
{
  if(bios_error)
  {
    if(bios_error <= 12) return dos_errors[bios_error-1];
    if(bios_error == 0x10) return 0x04; // data error
    if(bios_error == 0x40) return 0x06; // seek error
    if(bios_error == 0x80 || bios_error == 0xAA) return 0x02; // not ready
  }
  return 0x0C;
}
