#include <stdio.h>
#include <i86.h>
#include <dos.h>
#include <limits.h>

char __based(__segname("_CODE")) cddevname[] = "CD0";

typedef unsigned long dirindex_t;
typedef unsigned long seekpos_t;

unsigned char __based(__segname("_CODE")) error_code = 0;
//#pragma aux kernel_criterr_hdl parm [ax] [di] value [ax];
unsigned __far (* __based(__segname("_CODE")) kernel_criterr_hdl)(unsigned, unsigned);
//#pragma aux kernel_criterr_hdl parm [ax] [di] value [ax];

struct diskfree
{
  unsigned clusters;
  unsigned bytes_per_sector;
  unsigned unused_clusters;
  unsigned char sectors_per_cluster;
};

struct time
{
  unsigned char ssecond:7;
  unsigned char second:6;
  unsigned char minute:6;
  unsigned char hour:5;
};

struct date
{
  unsigned year:11;
  unsigned char day:5;
  unsigned char month:4;
};

struct file_info
{
  unsigned long size;
  struct time time;
  struct date date;
  unsigned char attr;
};

void get_dos_dmabuffer(void *ret);
#pragma aux get_dos_dmabuffer = \
  "mov ah, 0x6a" \
  "mov cx, 6" \
  "int 0x21" \
  parm [di];

unsigned current_psp(void);
#pragma aux current_psp = \
  "mov ah, 0x51" \
  "int 0x21" \
  value [bx] modify [ax];

unsigned char inbyte(unsigned port);
#pragma aux inbyte = \
  "in al, dx" \
  parm [dx] value [al];

void outbyte(unsigned port, unsigned char byte);
#pragma aux outbyte = \
  "out dx, al" \
  parm [dx] [ax];

int driver_sendcmd(void __far*, void *);
#pragma aux driver_sendcmd = \
  "mov ah, 0x6b" \
  "int 0x21" \
  value [ax] parm [dx bx] [di];

void __far *dos_alloc(unsigned bytes);
#pragma aux dos_alloc = \
  "push cx" \
  "mov cl, 4" \
  "add bx, 0xF" \
  "shr bx, cl" \
  "pop cx" \
  "mov ah, 0x48" \
  "int 0x21" \
  "jnc end" \
  "xor ax, ax" \
  "end:" \
  "xor dx, dx" \
  "xchg ax, dx" \
  parm [bx] value [dx ax];

void __far dos_free(unsigned seg);
#pragma aux dos_free = \
  "mov ah, 0x49" \
  "mov es, bx" \
  "int 0x21" \
  parm [bx] modify [es ax];

void memset(void __far *dst, unsigned char chr, unsigned count);
#pragma aux memset = \
  "rep stosb" \
  parm [es di] [ax] [cx];

void memcpy(void __far *dst, void __far *src, unsigned count);
#pragma aux memcpy = \
  "push ds" \
  "mov ds, dx" \
  "rep movsb" \
  "pop ds" \
  parm [es di] [dx si] [cx];

int dos_open(unsigned mode, char __far *filename);
#pragma aux dos_open = \
  "push ds" \
  "mov ds, cx" \
  "mov ah, 0x3d" \
  "int 0x21" \
  "jnc noerror" \
  "mov cs:error_code, al" \
  "mov ax, -1" \
  "noerror:" \
  "pop ds" \
  parm [ax] [cx dx] value [ax];

int dos_close(unsigned handle);
#pragma aux dos_close = \
  "mov ah, 0x3e" \
  "int 0x21" \
  parm [bx] value [ax];

unsigned dos_read(unsigned handle, void __far *buff, unsigned count);
#pragma aux dos_read = \
  "push ds" \
  "mov ax, es" \
  "mov ds, ax" \
  "mov ah, 0x3f" \
  "int 0x21" \
  "jnc noerror" \
  "mov cs:error_code, al" \
  "mov ax, -1" \
  "noerror:" \
  "pop ds" \
  parm [bx] [es dx] [cx] value [ax];

unsigned long dos_seek(unsigned handle, long count, unsigned origin);
#pragma aux dos_seek = \
  "mov ah, 0x42" \
  "int 0x21" \
  parm [bx] [cx dx] [ax] value [dx ax];

void seek_sector(unsigned handle, unsigned long sector)
{
  long sc;
  dos_seek(handle, 0, 0);

  do
  {
    if(sector & 0xFFF00000)
    {
      sector -= 0x80000;
      sc = 0x80000 << 11;
    }
    else
    {
      sc = sector << 11;
      sector = 0;
    }
    dos_seek(handle, sc, 1);
  }
  while(sector);
}

void debug(unsigned char chr);
#pragma aux debug = \
  "mov ah, 0x0E" \
  "mov bx, 0x0007" \
  "int 0x10" \
  parm [al] modify [bx];

#define MAX_DIR_DEPTH 6
struct fs_status
{
  dirindex_t working_directory[MAX_DIR_DEPTH+1];
  unsigned long block_count;
  unsigned long rootdir_start_block;
  unsigned long rootdir_length;
  unsigned long workdir_start_block;
  unsigned long workdir_length;
  unsigned handle;
  unsigned char drive;
  unsigned char devnum;
  unsigned in_use:1;
  unsigned image:1;
};

struct fs_status __far* __based(__segname("_CODE")) fs_statust;
unsigned char __far * __based(__segname("_CODE")) work_buff;

unsigned long clock_ticks(void);
#pragma aux clock_ticks = \
  "push ax" \
  "xor ah, ah" \
  "int 0x1A" \
  "pop ax"  \
  value [cx dx];

struct fs_status __far *fs_struct(unsigned char drive)
{
  unsigned n;
  for(n=0;n<25;n++)
    if(fs_statust[n].in_use && fs_statust[n].drive == drive)
      return &fs_statust[n];

  return 0;
}

#include "errors.c"
#include "isofunc.c"

#pragma aux fs_chdir parm [bx] [dx ax] modify exact [];
void __far fs_chdir(unsigned char drive, dirindex_t __far *index)
{
  chdir(drive, index);
}

#pragma aux fs_getcwd parm [bx] [dx ax] value [ax] modify exact [ax];
int __far fs_getcwd(unsigned char drive, dirindex_t __far *index)
{
  return getcwd(drive, index);
}

int __far fs_changed(unsigned char drive)
{
  struct fs_status __far *fs_status = fs_struct(drive);

  if(fs_status->image)
    return 0;
  cddevname[2] = fs_status->devnum + '0';
  if(driver_sendcmd(cddevname, 0))
    if(mount_fs(fs_status) == -1)
      return -1;
    else
      return 1;
  return 0;
}

#pragma aux fs_free_space parm [bx] [ax] value [ax] modify exact [ax];
void __far fs_free_space(unsigned char drive, struct diskfree *retval)
{
  free_space(drive, retval);  
}

#pragma aux fs_direntry parm [dx ax] [cx] [bx] value [ax] modify exact [ax];
int __far fs_direntry(dirindex_t index,
                unsigned char __far **buff, unsigned hcount_ldrive)
{
  return directory_entry(hcount_ldrive & 0xFF, index, *buff, hcount_ldrive >> 8);
}

#pragma aux fs_fileinfo parm [dx ax] [cx] [bx] value [ax] modify exact [ax];
int __far fs_fileinfo(dirindex_t file_index, struct file_info *ret,
                      unsigned drive)
{
  return fileinfo(drive, file_index, ret);
}

#pragma aux fs_gethandlestatinfo value [dx ax] parm [bx] [dx ax] modify exact [dx ax];
unsigned long __far fs_gethandlestatinfo(unsigned char drive, dirindex_t index)
{
  return gethandlestaticinfo(drive, index);
}

#pragma aux fs_readfile value [ax] parm [ax] [bx] [cx] [dx] [si] modify exact [ax];
unsigned __far fs_readfile(unsigned long *offset, dirindex_t __far **file_index, 
                     unsigned count, void __far **buff, unsigned handle_seg)
{
  return read_file(*offset, *file_index, count, *buff, handle_seg);
}


unsigned __far get_error(void);
#pragma aux get_error value [ax] modify exact [ax];
unsigned __far get_error(void)
{
  unsigned retval = error_code;
  error_code = 0;
  return retval;
}

#pragma aux fsdriver_mount parm [bx] [dx ax] value [ax] modify exact [ax];
int __far fsdriver_mount(unsigned char drive, char __far *imagefile)
{
  unsigned n;

  for(n=0;fs_statust[n].in_use;n++);

  fs_statust[n].working_directory[0] = -1;

  if(imagefile)
  {
    fs_statust[n].handle = dos_open(0, imagefile);
  }
  else
  {
    cddevname[2] = '0' + n;
    fs_statust[n].handle = dos_open(0, cddevname);
  }
  if(fs_statust[n].handle != -1)
  {
    fs_statust[n].drive = drive;
    fs_statust[n].in_use = 1;
    if(fs_statust[n].image = !!imagefile)
      mount_fs(&fs_statust[n]);
  }

  if(!imagefile) return 1;
  return 0;
}

#pragma aux fsdriver_unmount parm [bx] value [ax] modify exact [ax];
int __far fsdriver_unmount(unsigned char drive)
{
  struct fs_status __far *fs_status = fs_struct(drive);
  if(fs_status)
    fs_status->in_use = 0;
  return 0;
}

#pragma aux fs_rawread parm [bx] [dx ax] [si] [cx] value [ax] modify exact [ax];
unsigned __far fs_rawread(unsigned char drive, unsigned long offset,
                    void __far **buff, unsigned count)
{
  struct fs_status __far *fs_status = fs_struct(drive);
  unsigned long fs_size = fs_status->block_count<<11;

  if(offset > fs_size) return 0;
  if(offset + count > fs_size)
    count = fs_size - offset;
  dos_seek(fs_status->handle, offset, 0);
  return read_drive(fs_status, *buff, count);
}

int mount_partition_pragma(void *, void __far*);
#pragma aux mount_partition_pragma = \
  "push cx" \
  "mov cx, 4" \
  "mov ah, 0x6a" \
  "int 0x21" \
  "jnc no_error" \
  "mov cs:error_code, al" \
  "mov ax, -1" \
  "no_error:" \
  "pop cx" \
  value [ax] parm [di] [dx bx];

int install_driver(char __far *, void *);
#pragma aux install_driver = \
  "mov ah, 0x6A" \
  "mov cx, 1" \
  "push ds" \
  "push cs" \
  "pop ds" \
  "int 0x21" \
  "pop ds" \
  "jnc noerror" \
  "mov cs:error_code, al" \
  "mov ax, -1" \
  "jmp end" \
  "noerror:" \
  "xor ax, ax" \
  "end:" \
  parm [dx bx] [di] value [ax] modify [cx];

  void __far * __based(__segname("_CODE")) function_table[] =
  {
    fs_chdir,
    fs_getcwd,
    fs_changed,
    fs_free_space,
    fs_direntry,
    fs_fileinfo,
    fs_gethandlestatinfo,
    fs_readfile,
    0, // fs_rename
    0, // fs_writefile
    0, // fs_truncate
    0, // fs_creatfile
    0, // fs_createdir
    0, // fs_updatefileinfo_nohdl
    0, // fs_updatefileinfo
    0, // fs_setfileinfo
    0, // fs_delete
    fsdriver_mount,
    fsdriver_unmount,
    fs_rawread,
    0, // fs_rawrite
    get_error
  };

void set_memory_allocation_strategy(unsigned strategy);
#pragma aux set_memory_allocation_strategy = \
  "mov ax, 0x5801" \
  "int 0x21" \
  parm [bx];

int iso_initialize(void);
unsigned char mount_partitions(int);

void uninstall_driver(char __far *devname);
#pragma aux uninstall_driver = \
  "mov ah, 0x6c" \
  "int 0x21" \
  parm [dx bx];

unsigned get_kernel_cs(void);
#pragma aux get_kernel_cs = \
  "mov ah, 0x18" \
  "int 0x21" \
  value [dx] modify [ax];

int mount_partition(unsigned char drive,
                    unsigned sector_size, 
                    char __far *drvname)
{
  unsigned char strct[12];
  strct[0] = drive;
  strct[1] = 0x80;
  *(unsigned*)&strct[2] = sector_size;
  *(unsigned long*)&strct[4] = -1;
  *(unsigned long*)&strct[8] = 0;

  return mount_partition_pragma(strct, drvname);
}


int main(char argc, char **argv)
{
  unsigned env_seg;
  unsigned char __far *psp_ptr = MK_FP(current_psp(), 0);
  int rc;
  unsigned char drive;
  char drivername[] = "ISO";
  unsigned *kernel_criterr_off = (unsigned*)drivername;
  unsigned n;

  if(argc == 2) drive = argv[1][0] - 'A';
  else drive = 3;

  puts("Installing ISO9660 filesystem driver v1.1.");

  set_memory_allocation_strategy(2);
  rc = iso_initialize();
  set_memory_allocation_strategy(0);
  if(rc)
  {
    puts("Error");
    return 1;
  }

  if(!install_driver(drivername, function_table))
  {
    kernel_criterr_hdl = MK_FP(get_kernel_cs(), *kernel_criterr_off);
    puts("Installed ISO9660 driver - now mounting drives...");
    rc = mount_partitions(drive);
    if(!rc)
    {
      puts("No partitions mounted, exiting...");
      uninstall_driver("ISO");
      return 1;
    }
    puts("Done, going resident...");

    env_seg = *(unsigned __far*)&psp_ptr[0x2C];
    dos_free(env_seg);

    for(n=3;n--;)
      dos_close(n);

    _dos_keep(0, 0x10 + ((FP_OFF(mount_partition) + SECTOR_SIZE + 0xF) >> 4));
  }
  puts("Error");
  return 1;
}

unsigned char mount_partitions(int drive)
{
  unsigned handle;
  unsigned char d;
  unsigned char mounted = 0;
  int rc;


  for(d=0;;d++)
  {
    cddevname[2] = '0' + d;
    handle = dos_open(0, cddevname);
    if(error_code)
    {
      error_code = 0;
      break;
    }
    dos_close(handle);
    rc = mount_partition(drive, SECTOR_SIZE, "ISO");
    if(rc == -1) 
    {
      printf("Error %X\n", error_code);
    }
    else
    {
//      printf("Mounted CD%u to drive %c\n", d, 'A' + rc);
      printf("Mounted %Fs to drive %c\n", (char __far*)cddevname, 'A' + rc);
      fs_struct(rc)->devnum = d;
      mounted++;
    }
  }
  return mounted;
}

int iso_initialize(void)
{
  fs_statust = dos_alloc(25*sizeof(struct fs_status));
  if(!fs_statust) return 1;
  work_buff = (void __far*)mount_partition;
  memset(fs_statust, 0, 25*sizeof(struct fs_status));

  return 0;
}

