.8086

.MODEL small

extern getcode_:BYTE
extern unload_keyb_:BYTE
extern _my_psp:WORD
extern _local_ptrs:BYTE
public kbd_hdl_
public _bios_kbd_hdl
public int2fhdl_
public _old_int2f_hdl
public _int21_handler

_TEXT               SEGMENT BYTE PUBLIC USE16 'CODE'
                ASSUME CS:_TEXT                               

kbd_hdl_ proc far
  push ax
  call near ptr getcode_
  test al, al
  jz jmpbioshdl

  in al, 0x61
  xchg ah, al
  or al, 0x80
  out 0x61, al
  mov al, ah
  out 0x61, al

  mov al, 0x20
  out 0x20, al

  pop ax

  iret

  jmpbioshdl:
  pop ax
  db 0xEA
  _bios_kbd_hdl: dd 0
kbd_hdl_ endp

int2fhdl_ proc far
  pushf
  cmp ax, 0xAD80
  je keyb_loaded
  cmp ax, 0xAD86
  je keyb_unload
  cmp ax, 0xAD87
  je keyb_getptrs
  jmp int2f_chain

  keyb_loaded:
  dec bx
  popf
  iret

  keyb_getptrs:
  mov dx, cs
  mov ax, offset _local_ptrs
  popf
  iret

  keyb_unload:
  call near ptr unload_keyb_
  add sp, 2

  mov es, cs:_my_psp
  mov ah, 0x49

  ; jump directly to int21h handler to prevent returning to this freed code
  db 0xEA
  _int21_handler: dd 0

  int2f_chain:
  popf
  db 0xEA
  _old_int2f_hdl: dd 0
int2fhdl_ endp

_TEXT ENDS

END
