.8086

.MODEL tiny
                              
.code

ORG 0x100

start:
mov debug_ss, ss
mov debug_sp, sp
call open_serialport_handle
call save_kernel_21h
mov bx, offset loaded
call writestr_serport
mov bx, offset newline
call writestr_serport

parameter_block EQU end_code
args EQU parameter_block+22

mov bx, 0x81
find_filename_end:
inc bx
cmp byte ptr [bx], ' '
jg find_filename_end
mov al, [bx]
mov byte ptr [bx], 0

inc bx

cmp al, ' '
jge args_nozero
mov byte ptr [bx], al
args_nozero:

xor di, di
xor cl, cl

copy_args_loop:
mov al, byte ptr [bx]
cmp al, ' '
jl copy_args_end
mov byte ptr [args+1+di], al
inc bx
inc di
inc cl
jmp copy_args_loop
copy_args_end:
mov byte ptr args, cl
mov byte ptr [args+1+di], 0x0D
mov byte ptr [args+2+di], 0

mov bx, offset starting
call writestr_serport
mov bx, 0x81
call writestr_serport
mov bx, offset newline
call writestr_serport
mov bx, offset with_args
call writestr_serport
mov bx, offset args+1
call writestr_serport
mov bx, offset newline+1
call writestr_serport

call set_this_21h

mov ax, 0x4B00
mov dx, 0x81
mov bx, offset parameter_block
mov word ptr [bx], 0

mov word ptr [bx+2], offset args
mov word ptr [bx+4], ds

mov word ptr [bx+6], 0
mov word ptr [bx+8], 0

mov word ptr [bx+10], 0
mov word ptr [bx+12], 0

mov word ptr [bx+14], 0
mov word ptr [bx+16], 0

mov word ptr [bx+18], 0
mov word ptr [bx+20], 0

jmp jump

loaded: db "COMDEBUG loaded."
newline: db 0x0D, 0x0A, 0
starting: db "Starting ", 0
with_args: db "With arguments ", 0
serialport_handle: dw 0
serialport_name: db "COM1", 0

open_serialport_handle proc near
  mov ax, 0x3D01
  mov dx, offset serialport_name
  int 0x21
  mov serialport_handle, ax
  ret
open_serialport_handle endp

debug_ss: dw 0
debug_sp: dw 0
program_sp: dw 0
program_ss: dw 0
 

syscall_str: db "Syscall ", 0
returns_str: db "Returns ", 0
int21_wrapper proc near
  mov cs:program_sp, sp
  mov cs:program_ss, ss

  mov ss, cs:debug_ss
  mov sp, cs:debug_sp

  pushf
  push ax
  push cx
  push dx
  push di
  push si
  push bp
  push es
  push ds
  push bx

  push cs
  pop ds

  pushf

  call set_kernel_21h

  call save_program_psp

  call set_this_psp

  mov bx, offset syscall_str
  call writestr_serport

  popf
  pop bx
  push bx
  call write_regs

  call set_program_psp

  pop bx
  pop ds
  pop es
  pop bp
  pop si
  pop di
  pop dx
  pop cx
  pop ax
  popf

  mov ss, cs:program_ss
  mov sp, cs:program_sp

  jump:
  pushf
  db 0x9A
  int21_handler: dd 0 

  mov ss, cs:debug_ss
  mov sp, cs:debug_sp

  pushf
  push ax
  push cx
  push dx
  push di
  push si
  push bp
  push es
  push ds
  push bx

  push cs
  pop ds

  pushf

  call set_this_psp

  mov bx, offset returns_str
  call writestr_serport

  popf
  pop bx
  push bx
  call write_regs

  mov bx, offset newline
  call writestr_serport

  call set_program_psp

  call set_this_21h

  pop bx
  pop ds
  pop es
  pop bp
  pop si
  pop di
  pop dx
  pop cx
  pop ax

  push es
  push ax
  push bx


  mov bx, sp
  mov ax, ss:[bx+6] ; flags to ax
  mov es, cs:program_ss
  mov bx, cs:program_sp
  mov es:[bx+4], ax

  pop bx
  pop ax
  pop es
  popf

  mov ss, cs:program_ss
  mov sp, cs:program_sp

  iret
int21_wrapper endp

save_kernel_21h proc near
  push es
  push bx
  push ax

  xor ax, ax
  mov es, ax

  mov bx, 0x21*4
  mov ax, word ptr es:[bx]
  mov word ptr int21_handler, ax

  mov ax, word ptr es:[bx+2]
  mov word ptr int21_handler+2, ax

  pop ax
  pop bx
  pop es
  ret
save_kernel_21h endp

set_kernel_21h proc near
  push es
  push bx
  push ax

  xor ax, ax
  mov es, ax
  mov bx, 0x21*4

  mov ax, word ptr int21_handler
  mov word ptr es:[bx], ax
  mov ax, word ptr int21_handler+2
  mov word ptr es:[bx+2], ax

  pop ax
  pop bx
  pop es
  ret
set_kernel_21h endp

set_this_21h proc near
  push es
  push bx
  push ax

  xor ax, ax
  mov es, ax
  mov bx, 0x21*4

  mov ax, offset int21_wrapper
  mov word ptr es:[bx], ax
  mov ax, cs
  mov word ptr es:[bx+2], ax

  pop ax
  pop bx
  pop es
  ret
set_this_21h endp

program_psp: dw 0

save_program_psp proc near
  push ax
  push bx
  mov ah, 0x51
  int 0x21
  mov program_psp, bx
  pop bx
  pop ax
  ret
save_program_psp endp

set_this_psp proc near
  push ax
  push bx

  mov bx, cs
  mov ah, 0x50
  int 0x21
  pop bx
  pop ax
  ret
set_this_psp endp

set_program_psp proc near
  push ax
  push bx
  mov ah, 0x50
  mov bx, program_psp
  int 0x21
  pop bx
  pop ax
  ret
set_program_psp endp

; bx == pointer to string
writestr_serport proc near
  push ax
  push cx
  push dx
  mov ah, 0x40
  push bx
  xor cx, cx
  writestr_serport_strlen:
  test byte ptr [bx], 0xFF
  jz writestr_serport_strlen_end
  inc cx
  inc bx
  jmp writestr_serport_strlen
  writestr_serport_strlen_end:
  pop bx
  mov dx, bx
  push bx
  mov bx, serialport_handle
;  mov bx, 1

  int 0x21

  pop bx
  pop dx
  pop cx
  pop ax
  ret
writestr_serport endp

hexstr: db "ABCD ", 0

axstr: db "AX=", 0
bxstr: db "BX=", 0
cxstr: db "CX=", 0
dxstr: db "DX=", 0
sistr: db "SI=", 0
distr: db "DI=", 0
bpstr: db "BP=", 0
dsstr: db "DS=", 0
spstr: db "SP=", 0
ssstr: db "SS=", 0
esstr: db "ES=", 0
flstr: db "FLAGS=", 0

write_hex proc near
  push ax
  push bx
  push cx

  mov bx, 4
  write_hex_loop:

  mov cl, al
  and cl, 0x0F

  cmp cl, 10
  jl write_hex_lessthan10

  add cl, 'A' - 10
  jmp write_hex_save

  write_hex_lessthan10:
  add cl, '0'

  write_hex_save:  
  dec bx
  mov byte ptr [bx+hexstr], cl
  jz write_hex_end
  
  mov cl, 4
  shr ax, cl

  jmp write_hex_loop

  write_hex_end:

  mov bx, offset hexstr
  call writestr_serport
  
  pop cx
  pop bx
  pop ax
  ret
write_hex endp

write_regs proc near
  pushf
  push bx
  mov bx, offset axstr
  call writestr_serport
  call write_hex
  mov bx, offset bxstr
  call writestr_serport

  pop bx
  push ax
  mov ax, bx
  call write_hex
  pop ax  
  popf

  push bx
  push ax
  pushf

  mov bx, offset cxstr
  call writestr_serport
  mov ax, cx
  call write_hex

  mov bx, offset dxstr
  call writestr_serport
  mov ax, dx
  call write_hex

  mov bx, offset sistr
  call writestr_serport
  mov ax, si
  call write_hex

  mov bx, offset distr
  call writestr_serport
  mov ax, di
  call write_hex

  mov bx, offset bpstr
  call writestr_serport
  mov ax, bp
  call write_hex

  mov bx, offset ssstr
  call writestr_serport
  mov ax, program_ss
  call write_hex

  mov bx, offset spstr
  call writestr_serport
  mov ax, program_sp
  call write_hex

  mov bx, offset dsstr
  call writestr_serport
  mov bx, sp
  mov ax, [bx+10]
  call write_hex

  mov bx, offset esstr
  call writestr_serport
  mov ax, es
  call write_hex

  mov bx, offset flstr
  call writestr_serport
  pop bx
  push bx
  mov ax, bx
  call write_hex

  mov bx, offset newline
  call writestr_serport

  popf
  pop ax
  pop bx

  ret  
write_regs endp

end_code: 

END start
