#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>
//#include <process.h>
#include <direct.h>
#include <env.h>
#include <conio.h>
#include <malloc.h>

#define CMDLEN 256

char dotbat[] = ".bat";

char forcmd[] = "for";

char *autoexecbat[] = { "autoexec.bat" };

int errorlevel = 0;
unsigned batch_depth = 0;

struct ftime
{
  unsigned twosec:5;
  unsigned minute:6;
  unsigned hour:5;
};

struct fdate
{
  unsigned day:5;
  unsigned month:4;
  unsigned year:7;
};

int parse_command_2(char *, char **);

int parse_command(char *command, int argc, char *argv[], char **retstr);

unsigned char get_screen_rows();
unsigned char get_screen_cols();

unsigned to_bcd(unsigned num)
{
  return (num / 10 * 0x10) | (num % 10);
}

void set_cmos_time(void)
{
  struct dostime_t time;
  struct dosdate_t date;
  unsigned char second, minute, hour;
  unsigned char day, month, year, weekday;
  unsigned char __far *machine_identification = MK_FP(0xF000, 0xFFFE);

  if(*machine_identification > 0xFC) return;

  _dos_gettime(&time);
  _dos_getdate(&date);
  second = to_bcd(time.second);
  minute = to_bcd(time.minute);
  hour = to_bcd(time.hour);

  day = to_bcd(date.day);
  month = to_bcd(date.month);
  year = to_bcd(date.year - 2000);
  weekday = date.dayofweek;

  __asm
  {
    xor al, al // second
    out 0x70, al
    hlt
    mov al, second
    out 0x71, al

    mov al, 2 // minute
    out 0x70, al
    hlt
    mov al, minute
    out 0x71, al

    mov al, 4 // hour
    out 0x70, al
    hlt
    mov al, hour
    out 0x71, al

    mov al, 6 // day of week
    out 0x70, al
    hlt
    mov al, weekday
    out 0x71, al

    mov al, 7 // day of month
    out 0x70, al
    hlt
    mov al, day
    out 0x71, al

    mov al, 8 // month
    out 0x70, al
    hlt
    mov al, month
    out 0x71, al

    mov al, 9 // year
    out 0x70, al
    hlt
    mov al, year
    out 0x71, al
  }
}

unsigned to_dec(unsigned num)
{
  return ((num >> 4) * 10) + (num & 0x0F);
}

struct dosdate_t get_cmos_date(void)
{
  struct dosdate_t retval;
  unsigned char day, month, year;

  __asm
  {
    mov al, 7
    out 0x70, al
    mov al, day // for delaying things
    in al, 0x71
    mov day, al

    mov al, 8
    out 0x70, al
    mov al, month
    in al, 0x71
    mov month, al

    mov al, 9
    out 0x70, al
    mov al, year
    in al, 0x71
    mov year, al
  }
  retval.day = to_dec(day);
  retval.month = to_dec(month);
  retval.year = to_dec(year) + 2000;

  return retval;
}

char nomemoryerror[] = "Out of memory.";

#include "dosexec.c"

#define FLAG_ECHO 0x01
#define FLAG_PERM 0x02
unsigned char flags = FLAG_ECHO;

unsigned long get_cursor_position(void);
#pragma aux get_cursor_position = \
  "push bx" \
  "push ax" \
  "push bp" \
  "xor bx, bx" \
  "mov ah, 3" \
  "int 0x10" \
  "pop bp" \
  "pop ax" \
  "pop bx" \
  value [cx dx];

void set_cursor_position(unsigned pos);
#pragma aux set_cursor_position =  \
  "push ax" \
  "push bx" \
  "push bp" \
  "xor bx, bx" \
  "mov ah, 2" \
  "int 0x10" \
  "pop bp" \
  "pop bx" \
  "pop ax" \
  parm [dx];

void print_string(char __far *str);
#pragma aux print_string = \
  "push ax" \
  "push ds" \
  "mov ax, es" \
  "mov ds, ax" \
  "mov ah, 0x09" \
  "int 0x21" \
  "pop ds" \
  "pop ax" \
  parm [es dx];


/*void end_program();
#pragma aux end_program = \
  "mov ax, 0x4C00" \
  "int 0x21";

void break_handler(void);
#pragma aux break_handler aborts;
void break_handler(void)
{
  end_program();
}*/

int exists(char *);
int is_dir(char *);

#include "cmdcopy.c"

void print_time()
{
  unsigned cursor_pos = get_cursor_position();
  char timestr[25];
  struct dostime_t time;
  static unsigned char oldsec;
  struct dosdate_t date;
  unsigned *dateptr = (unsigned*)&date;
  unsigned char *timeptr = (unsigned char*)&time;
  char *weekdays[] =
  {
    "sun", "mon", "tue", "wed", "thu", "fri", "sat"
  };

  _dos_gettime(&time);
  if(time.second == oldsec) return;
  oldsec = time.second;

  _dos_getdate(&date);

  sprintf(timestr, "%s %u. %u. %u %.2u:%.2u:%.2u$", weekdays[date.dayofweek], date.day, date.month, date.year,
          time.hour, time.minute, time.second);

  set_cursor_position(50);
  print_string(timestr);
  set_cursor_position(cursor_pos);
}

void skip_whitespaces(char **ptr)
{
  while(**ptr == ' ')
    ++*ptr;
}

void skip_word(char **ptr)
{
  while(**ptr && **ptr != ' ')
    ++*ptr;
}

int split_args(char *cmdtail, char **dst, unsigned max_arg_count)
{
  unsigned retval = 0;
  while(*cmdtail)
  {
    skip_whitespaces(&cmdtail);
    if(*cmdtail)
    {
      dst[retval] = cmdtail;
      retval++;
      if(retval == max_arg_count) break;
    }
    skip_word(&cmdtail);
    *cmdtail++ = 0;
  }
  return retval;
}

void get_keypress(void)
{
  puts("Press enter to continue...");
  getch();
}

void dir(char *cmdtail)
{
  struct find_t fstrct;
  unsigned rc;
  char allfiles[] = "*.*";
  char *filenames = allfiles;
  unsigned long long total_size = 0;
  unsigned long files = 0;
  struct diskfree_t diskfree;
  unsigned long long free_space;
  struct ftime *ftime = (void *)&fstrct.wr_time;
  struct fdate *fdate = (void *)&fstrct.wr_date;
  char *args[8];
  unsigned argc;
  unsigned n;
  unsigned char flags = 0;
#define DIR_PAGED_FLAG 0x01
#define DIR_SEARCH_FLAG 0x02

  puts("Listing directory entries...");

  if(cmdtail)
  {
    argc = split_args(cmdtail, args, 8);
    for(n=0;n<argc;n++)
    {
      if(args[n][0] != '/')
        filenames = args[n];
    }
    for(n=0;n<argc;n++)
      if(args[n][0] == '/') switch(args[n][1]&0x1F)
      {
        case 'P'&0x1F:
          flags |= DIR_PAGED_FLAG;
          break;
        case 'S'&0x1F:
          if(dosexec("DIRFIND.COM", filenames))
            puts("Cannot find DIRFIND.COM");
          return;
      }
  }

  rc = _dos_findfirst(filenames, 0x10, &fstrct);

  while(!rc)
  {
    printf("%12s ", fstrct.name);
    if(!(fstrct.attrib & 0x40))
      if(!(fstrct.attrib & _A_SUBDIR))
      {
        printf("%12ld ", fstrct.size);
        total_size += fstrct.size;
      }
      else
        printf("       <DIR> ", fstrct.name);
    else
      if(fstrct.attrib & _A_SUBDIR)
        printf(" <LINK><DIR> ", fstrct.name);
      else
        printf("      <LINK> ", fstrct.name);
    printf(" %2u.%2u.%2u %.2u:%.2u:%.2u\n", fdate->day, fdate->month,
           (fdate->year+80)%100, ftime->hour, ftime->minute, ftime->twosec<<1);
      
    rc = _dos_findnext(&fstrct);
    files++;
    if((flags & DIR_PAGED_FLAG) && !(files % (get_screen_rows()-4)))
      get_keypress();
  }  

  puts("Directory listing complete.");
  printf("%lu files, %llu bytes\n", files, total_size);

  _getdiskfree(0, &diskfree);
  free_space = (unsigned long long)diskfree.bytes_per_sector
                 * (unsigned long long)diskfree.sectors_per_cluster
                 * (unsigned long long)diskfree.avail_clusters;
  printf("%llu bytes free.\n", free_space);
  

  return;
}

char toupper(char chr)
{
  if(chr >= 'a' && chr <= 'z')
    return chr - 0x20;
  return chr;
}

int istrncmp(char *str1, char *str2, unsigned count)
{
  while(*str1 && *str2 && toupper(*str1) == toupper(*str2) && --count)
  {
    str1++;
    str2++;
  }
  return toupper(*str1) - toupper(*str2);
}

int first_word_equals(char *command, char *word)
{
  unsigned wordlen = strlen(word);
  if(!istrncmp(command, word, wordlen) &&
       (command[wordlen] == ' ' || !command[wordlen]))
    return 1;
  return 0;
}

int run_program(char *command)
{
  char *command_tail = strchr(command, ' ');
//  int rc;

  if(command_tail)
    *command_tail++ = 0;

  return dosexec(command, command_tail);
//  return spawnl(P_WAIT, command, command, command_tail, 0);
}

void type(char *file)
{
  FILE *fp;
  char buff[512];
  if(!file) return;

  fp = fopen(file+1, "rt");

  if(!fp)
  {
    puts("Error opening file");
    return;
  }

  while(fgets(buff, 512, fp))
    printf("%s", buff);

  fclose(fp);
}

void cd(char *str)
{
  char *cwd;
  if(!str)
  {
    cwd = getcwd(0, 0xFF);
    if(cwd) puts(cwd);
  }
  else
  {
    if(chdir(str+1))
      printf("%.2X %s\n", errno, strerror(errno));
  }
}

void set(char *cmdtail)
{
  char *env;
  char *equals;
  char **envs;

  if(!cmdtail)
  {
    envs = environ;
    do
      puts(*envs);
    while(*++envs);
  }
  else if(!(equals = strchr(cmdtail, '=')))
  {
    env = getenv(&cmdtail[1]);
    if(env)
      printf("%s=%s\n", &cmdtail[1], env);
  }
  else
  {
    *equals = 0;
    setenv(&cmdtail[1], equals+1, 1);
  }
}

void show_time(void)
{
  struct dostime_t time;
  char newtime[20];

  _dos_gettime(&time);

  printf("%u:%.2u:%.2u.%.2u\n", time.hour, time.minute, time.second, time.hsecond);

  gettime:
  puts("Enter new time: (hh:mm:ss)");
  fgets(newtime, 20, stdin);

  if(*newtime != '\n')
  {
    sscanf(newtime, "%u:%u:%u", &time.hour, &time.minute, &time.second);
    if(_dos_settime(&time))
    {
      puts("Invalid time");
      goto gettime;
    }
    set_cmos_time();
  }
}

void show_date(void)
{
  struct dosdate_t date;
  char newdate[20];
  char *weekdays[] =
  {
    "sunday",
    "monday",
    "tuesday",
    "wednesday",
    "thursday",
    "friday",
    "saturday",
  };

  _dos_getdate(&date);

  printf("%s %u. %u. %u\n", weekdays[date.dayofweek], date.day, date.month, date.year);

  getdate:
  puts("Enter new date: (dd.mm.yyyy)");
  fgets(newdate, 20, stdin);
  if(*newdate != '\n')
  {
    sscanf(newdate, "%u.%u.%u", &date.day, &date.month, &date.year);
    if(_dos_setdate(&date))
    {
      puts("Invalid date");
      goto getdate;
    }
    set_cmos_time();
  }
}

void wordset(void __far *ptr, unsigned short word, unsigned short count);
#pragma aux wordset = \
  "cld" \
  "rep stosw" \
  parm [es di] [ax] [cx] modify exact [di cx];

unsigned char get_screen_cols(void)
{
  return *(unsigned char __far*)0x0040004AL;
}
unsigned char get_screen_rows(void)
{
  return *(unsigned char __far*)0x00400084L;
}

void scroll_screen(unsigned char count)
{
/*  void __far *vga = (void __far*)0xB8000000L;
  wordset(vga, 0x0720, 2000);*/
  const unsigned char cols = get_screen_cols();
  const unsigned char rows = get_screen_rows();

  __asm
  {
    mov al, count
    mov ah, 0x06
    xor cx, cx
    mov bh, 0x07
    mov dh, rows
    mov dl, cols
    int 0x10
  }

}

void clear_screen(void)
{
  scroll_screen(0);
  set_cursor_position(0);
}

void echo(char *command)
{
  if(!command) return;
  command++;

  if(!istrncmp(command, "on", 3))
    flags |= FLAG_ECHO;
  else if(!istrncmp(command, "off", 4))
    flags &= ~FLAG_ECHO;
  else puts(command);
}

int print_prompt(void);

int run_batch(unsigned argc, char *argv[], int *rc)
{
  char buff[CMDLEN];
  char *retstr;
  char *ptr;
  FILE *fp = fopen(argv[0], "rt");
  if(!fp)
  {
    if(argv != autoexecbat)
      puts("Could not open batch file");
    return -1;
  }

  batch_depth++;

  while(fgets(buff, CMDLEN, fp))
  {
    if(flags & FLAG_ECHO)
    {
      print_prompt();
      puts(buff);
    }
    if(*buff >= ' ' && *buff != ':')
      if((*rc = parse_command(buff, argc, argv, &retstr)) == 2)
      {
        if(retstr++)
        {
          rewind(fp);
          while(fgets(buff, CMDLEN, fp))
          {
            if(*buff == ':')
            {
              ptr = strchr(buff, '\n');
              if(ptr) *ptr=0;
              if(!strcmp(buff+1, retstr))
                break;
            }
          }
        }
      }
      else if(*rc & 1)
        break;
  }

  batch_depth--;

  fclose(fp);
  return 0;
}

int run_batch_wsargs(char *batch, char *args, int *rc)
{
  char *argv[32];
  unsigned n;

  argv[0] = batch;

  for(n=1;args;n++)
  {
//    args++;
    argv[n] = args;
    if(args = strchr(args, ' '))
      *args++ = 0;
  }

  return run_batch(n, argv, rc);
}

int delete(char *file)
{
  int rc = 0;
  char script[CMDLEN];
  char *ptr;
  if(file)
  {
    file++;
    if(strchr(file, '*') || strchr(file, '?'))
    {
      parse_source(file, script, "DEL");
      puts(script);
      return parse_command(script, 0, 0, 0);
    }
    else
    {
      if(ptr = strchr(file, ' '))
        *ptr = 0;
      if(rc = remove(file))
        printf("Could not delete file %s\n", file);
    }
  }
  return !!rc;
}

int move(char *cmd)
{
  copy(cmd);
  if(!errorlevel)
    return delete(cmd);
  else
    return errorlevel;
}

int createdir(char *dir)
{
  int rc = 0;
  if(dir)
    if(rc = mkdir(dir+1))
      puts("Error");

  return !!rc;
}

int deletedir(char *dir)
{
  int rc = 0;
  if(dir)
    if(rc = rmdir(dir+1))
      puts("Error");
  return !!rc;
}

void disable_caches(void);
#pragma aux disable_caches = \
  "mov ax, 0x6D03" \
  "int 0x21" \
  modify [ax];

void enable_caches(void);
#pragma aux enable_caches = \
  "mov ax, 0x6D04" \
  "int 0x21" \
  modify [ax];

void set_buffers(char *cmd)
{
  unsigned buffer_size;
  if(!cmd)
  {
    __asm
    {
      mov ax, 0x6D01
      int 0x21
      mov buffer_size, ax
    }
  }
  else
  {
    buffer_size = atoi(cmd);
    __asm
    {
      mov ax, 0x6D00
      mov bx, buffer_size
      int 0x21
    }
  }
  printf("File buffer size: %u\n", buffer_size);
}

void verify(char *cmd)
{
  unsigned char status;
  if(!cmd)
  {
    __asm
    {
      mov ah, 0x54
      int 0x21
      mov status, al
    }
  }
  else
  {
    status = atoi(cmd+1);
    __asm
    {
      mov ah, 0x2E
      mov al, status
      int 0x21
    }
  }

  printf("Verify status: %u\n", status);
}

int renamefile(char *cmd)
{
  char *oldname = cmd+1;
  char *newname;
  int rc = 0;
  if(!cmd)
  {
    puts("Arguments required");
    return 1;
  }
  newname = strchr(oldname, ' ');
  if(!newname)
  {
    puts("New name required");
    return 1;
  }
  *newname++ = 0;

  if(rc = rename(oldname, newname))
    puts("Error");
  return !!rc;
}

int exists(char *filename)
{
  struct find_t fstrct;

  return !_dos_findfirst(filename, 0x10, &fstrct);
}

int is_dir(char *filename)
{
  struct find_t fstrct;

  _dos_findfirst(filename, 0x10, &fstrct);
  return !!(fstrct.attrib & _A_SUBDIR);
}

int parseif(char *command, char **retstr)
{
  char *str_end;
  char *str1, *str2;
  char notcmd[] = "not";
  char not = 0;
  char errorlevelcmd[] = "errorlevel";
  char existcmd[] = "exist";
//  struct find_t fstrct;
  
  if(!*command++)
    return 0;

  if(not = first_word_equals(command, notcmd))
  {
    command = strchr(command, ' ');
    if(!*command++)
      return 0;
  }
  // now command points to the condition

  if(first_word_equals(command, errorlevelcmd))
  {
    command = strchr(command, ' ');
    if(!*command++)
      return 0;
    if((atoi(command) <= errorlevel) != not)
    {
      command = strchr(command, ' ');
      if(!*command++)
        return 0;
      return parse_command_2(command, retstr);
    }
  }
  else if(first_word_equals(command, existcmd))
  {
    command = strchr(command, ' ');
    if(!*command++)
      return 0;
    str_end = strchr(command, ' ');
    if(!str_end) return 0;
    *str_end = 0;
//    if(!_dos_findfirst(command, 0x10, &fstrct) != not)
    if(exists(command) != not)
    {
      command = str_end + 1;
      if(!*command) return 0;
      return parse_command_2(command, retstr);
    }
  }
  else
  {
    str1 = command;
    str_end = strchr(command, '=');
    if(!str_end) return 0;
    *str_end++ = 0;
    if(*str_end++ != '=') return 0;
    str2 = str_end;
    str_end = strchr(str2, ' ');
    if(!str_end) return 0;
    *str_end = 0;
    if(!strcmp(str1, str2) != not)
    {
      command = str_end + 1;
      if(!*command) return 0;
      return parse_command_2(command, retstr);
    }
  }
  return 0;
}

char *for_parse_pattern(char *command, struct find_t *fstrct, char *old_str_end, unsigned *n)
{
  char *str_end = strchr(command, ' ');
  if(!str_end)
    if(!(str_end = strchr(command, ')')))
      return 0;
  *old_str_end = *str_end;
  *str_end = 0;

  if(!strchr(command, '*') && !strchr(command, '?'))
    if(!(*n)++)
      return command;
    else
      return 0;
  else
    if(!(*n)++)
      if(!_dos_findfirst(command, _A_NORMAL, fstrct))
        goto dirchk;
      else return 0;
    else
    {
      while(!_dos_findnext(fstrct))
      {
        dirchk:if(strcmp(fstrct->name, "..") && strcmp(fstrct->name, "."))
          return fstrct->name;
      }
      return 0;
    }
}

void forcmd_replace_var(char *command, char *var, char *varstr)
{
  char *ptr;
  unsigned l1, l2;

  while(1)
  {
    do
    {
      ptr = strstr(command, var);
      if(!ptr) return;
      l1 = strlen(var);
    }
    while(ptr[l1] && ptr[l1] != ' ');  

    l2 = strlen(varstr);

    memmove(&ptr[l2], &ptr[l1], strlen(&ptr[l1])+1);
    memcpy(ptr, varstr, l2);
    command = &ptr[l2];
  }
}

int parsefor(char *command, char **retstr, int argc, char *argv[])
{
  unsigned n;
  int rc;
  char *str_end;
  char *pattern;
  char *loopcmd;
  char varname[3];
  struct find_t fstrct;
  char old_str_end;
  char loopcmdbak[CMDLEN];

  if(!command)
    return 0;

  str_end = strchr(command, ' ');
  if(!str_end) return 0;
  *str_end = 0;
  if(strlen(command) != 2) return 0;
  strcpy(varname, command);

  command = str_end+1;
  if(!first_word_equals(command, "in"))
    return 0;

  command += 2;
  if(*command++ != ' ')
    return 0;
  if(*command++ != '(')
    return 0;
  loopcmd = strchr(command, ')');
  if(!loopcmd++) return 0;
  if(*loopcmd != ' ') return 0;
  *loopcmd++ = 0;
  if(!first_word_equals(loopcmd, "do"))
    return 0;
  loopcmd += 2;
  if(*loopcmd++ != ' ')
    return 0;
  // now command points to the patterns, loopcmd points to the repeated command
  n = 0;
  while(*command != ')')
  {
    if(pattern = for_parse_pattern(command, &fstrct, &old_str_end, &n))
    {
      forcmd_replace_var(loopcmd, varname, pattern);
      strcpy(loopcmdbak, loopcmd);
      rc = parse_command(loopcmd, argc, argv, retstr);
      if(rc || errorlevel) return rc;
      strcpy(loopcmd, loopcmdbak);
      forcmd_replace_var(loopcmd, pattern, varname);
      *strchr(command, 0) = old_str_end;
    }
    else
    {
      command = strchr(command, 0);
      *command = old_str_end;
      if(*command != ')')
        command++;
      n = 0;
    }
  }
  return 0;
}

int try_run_batch(char *command, int *rc)
{
  char *argptr;
  unsigned n;
  struct find_t fstrct;
  char batfilename[13];

  for(n=0;n<8 && command[n] > ' ';n++)
    batfilename[n] = command[n];
  if(command[n] <= ' ')
    strcpy(&batfilename[n], dotbat);

  if(((argptr = strchr(command, ' ')) || (argptr = strchr(command, 0))) && first_word_equals(argptr-4, dotbat))
    return run_batch_wsargs(command, argptr, rc);
  else
    if(!_dos_findfirst(batfilename, 0x10, &fstrct))
      return run_batch_wsargs(batfilename, argptr, rc);

  else return 1;
}

int call_batch(char *command)
{
  int rc = 0;

  if(!command) return errorlevel = 0;
  command++;
  
  try_run_batch(command, &rc);
  if(rc == 3) return 1;
  return 0;
}

int batexit(char *command)
{
  unsigned char e = 0;
  if(command++)
  {
    if(*command == '/')
    {
      command+=2;
      e++;
    }
    while(*command == ' ')
      command++;
    errorlevel = atoi(command);
    if(!e) exit(errorlevel);
  }
  return 1;
}

unsigned long long get_version(void);
#pragma aux get_version = \
  "mov ah, 0x30" \
  "int 0x21" \
  "mov dx, cx" \
  "mov cx, bx" \
  "mov bx, ax" \
  "xor ax, ax" \
  value [ax bx cx dx];

void print_version(void)
{
  unsigned long long version = get_version();

  printf("DOS API Major version: %u\n", (version>>32) & 0xFF);
  printf("DOS API Minor version: %u\n", version>>40);
  printf("Vendor ID: %.2X\n", (version>>24) & 0xFF);
  printf("Version ID: %.5lX\n", version & 0xFFFFF);
  printf("Kernel build target: %X86\n", (version >> 20) & 0xF);
}

void set_caches(char *command)
{
  if(command++)
  {
    if(atoi(command))
      enable_caches();
    else
      disable_caches();
  }
}

int parse_command_2(char *command, char **retstr)
{
  char dircmd[] = "dir";
  char exitcmd[] = "exit";
  char typecmd[] = "type";
  char cdcmd[] = "cd";
  char setcmd[] = "set";
  char timecmd[] = "time";
  char datecmd[] = "date";
  char clscmd[] = "cls";
  char echocmd[] = "echo";
  char delcmd[] = "del";
  char copycmd[] = "copy";
  char mkdircmd[] = "mkdir";
  char rmdircmd[] = "rmdir";
  char renamecmd[] = "rename";
  char comment[] = "rem";
  char verifycmd[] = "verify";
  char ifcmd[] = "if";
  char gotocmd[] = "goto";
  char callcmd[] = "call";
  char vercmd[] = "ver";
  char buffcmd[] = "buffers";
  char movecmd[] = "move";
  char cachecmd[] = "cache";
  unsigned n = 0;
  char *ptr;

//  while(command[n] >= ' ')
//    n++;
//  command[n] = 0;   

  if(first_word_equals(command, dircmd))
    dir(strchr(command, ' '));
  else if(command[1] == ':' && !command[2])
    _dos_setdrive(toupper(command[0]) + 1 - 'A', &n);
  else if(first_word_equals(command, exitcmd))
    return batexit(strchr(command, ' '));
  else if(first_word_equals(command, typecmd))
    type(strchr(command, ' '));
  else if(first_word_equals(command, cdcmd))
    cd(strchr(command, ' '));    
  else if(first_word_equals(command, setcmd))
    set(strchr(command, ' '));
  else if(first_word_equals(command, timecmd))
    show_time();
  else if(first_word_equals(command, datecmd))
    show_date();
  else if(first_word_equals(command, clscmd))
    clear_screen();
  else if(first_word_equals(command, echocmd))
    echo(strchr(command, ' '));
  else if(first_word_equals(command, delcmd))
    errorlevel = delete(strchr(command, ' '));
  else if(first_word_equals(command, copycmd))
    errorlevel = copy(strchr(command, ' '));
  else if(first_word_equals(command, movecmd))
    errorlevel = move(strchr(command, ' '));
  else if(first_word_equals(command, mkdircmd))
    errorlevel = createdir(strchr(command, ' '));
  else if(first_word_equals(command, rmdircmd))
    errorlevel = deletedir(strchr(command, ' '));
  else if(first_word_equals(command, renamecmd))
    errorlevel = renamefile(strchr(command, ' '));
  else if(first_word_equals(command, verifycmd))
    verify(strchr(command, ' '));
  else if(first_word_equals(command, buffcmd))
    set_buffers(strchr(command, ' '));
  else if(first_word_equals(command, cachecmd))
    set_caches(strchr(command, ' '));
  else if(first_word_equals(command, vercmd))
    print_version();
  else if(first_word_equals(command, ifcmd))
    return parseif(strchr(command, ' '), retstr);
  else if(first_word_equals(command, gotocmd))
  {
    *retstr = strchr(command, ' ');
    return 2;
  }
//  else if(!try_run_batch(command))
//    return 0;
  else if(first_word_equals(command, callcmd))
    return call_batch(strchr(command, ' '));
  else if(first_word_equals(command, comment))
    return 0;
  else
    return run_program(command);

  return 0;
}

#define VARNAME_LEN 32

char *replace_command_variable(char *command, int argc, char *argv[])
{
  unsigned n;
  unsigned l;
  char varname[VARNAME_LEN];
  char *varptr;

  if(*command >= '0' && *command <= '9')
  {
    l = *command - '0';
    if(l < argc)
      varptr = argv[l];
    else
      varptr = strchr(command, 0);
    n = 1;
    goto replace;
  }  

  for(n=0;n < VARNAME_LEN && command[n] && command[n] != '%';n++)
    varname[n] = command[n];
  if(!n)
  {
    memmove(command, command+1, 1+strlen(command+1));
    return command+1;
  }
  if(n == VARNAME_LEN)
    return &command[n];
  varname[n] = 0;

  varptr = getenv(varname);
  if(!varptr) varptr = strchr(varname, 0);
  n++;

  replace:    
  l = strlen(varptr) - 1;
  memmove(&command[l], &command[n], 1+strlen(&command[n]));
  memcpy(command-1, varptr, strlen(varptr));

  return &command[l];
}

int parse_command(char *command, int argc, char *argv[], char **retstr)
{
  char *cmd = command;
  unsigned n;
  int rc;

  for(n=0;command[n]>=' ';n++);
  command[n] = 0;

  if(!first_word_equals(command, forcmd))
  {
    do
    {
      if(*command == '%')
        command = replace_command_variable(command+1, argc, argv);
    }
    while(*(++command));
/*    if(!try_run_batch(cmd, &rc))
    {
      return !!batch_depth;
    }
    else*/
      return parse_command_2(cmd, retstr);
  }
  else
    return parsefor(strchr(cmd, '%'), retstr, argc, argv);
}

unsigned add_cursor_pos(unsigned pos, signed count)
{
  unsigned char *col = ((unsigned char*)&pos);
  unsigned char *row = &col[1];
  signed char a;
  unsigned char cols;
  if(!count) return pos;
  if(count < 0) a = 1;
  else a = -1;

  do
  {
    *col += -a;
/*    if(*col >= get_screen_cols())
    {
      *col = 0;
      *row += -a;
      if(*row > get_screen_rows())
        *row = 0;
      else if(*row == get_screen_rows())
      {
        scroll_screen(1);
        *row--;
      }
    }*/
    if(*col == (cols = get_screen_cols()))
    {
      *col = 0;
      *row += -a;
      if(*row == get_screen_rows()+1)
      {
        scroll_screen(1);
        *row--;
      }
    }
    else if(*col > cols)
    {
      *col = cols - 1;
      *row += -a;
      if(*row > get_screen_rows())
        *row = 0;
    }
  }
  while(count += a);

  return pos;
}

void getcommand(char *command)
{
  unsigned n = 0;
  unsigned c;
  unsigned l=0;
  unsigned cpos = get_cursor_position();
  unsigned m;

  command[0] = 0;
  while(n+l < 255)
  {
    if(!kbhit())
      print_time();
    else
    {
      c = getch();
      if(!c)
      {
        c = getch();
        if(c == 75 && n) // left arrow
        {
          n--;
          cpos = add_cursor_pos(cpos, -1);
        }
        if(c == 71) // home
        {
          cpos = add_cursor_pos(cpos, -n);
          l += n;
          n = 0;
        }
        if(c == 77 && command[n]) // right arrow
        {
          n++;
          cpos = add_cursor_pos(cpos, 1);
        }
        if(c == 79) // end
        {
          cpos = add_cursor_pos(cpos, l);
          n += l;
          l = 0;
        }
        if(c == 83 && command[n])
        {
          memmove(&command[n], &command[n+1], (l = strlen(&command[n+1]))+1);
          printf("%s ", &command[n]);
          fflush(stdout);
          cpos = add_cursor_pos(get_cursor_position(), -l-1);
        }
        set_cursor_position(cpos);
        continue;
      }
      l = strlen(&command[n]);
      if(c == 8)
      {
        if(n)
        {
          
          memmove(&command[n-1], &command[n], l+1);
          n--;
          set_cursor_position(cpos = add_cursor_pos(cpos, -1));
          printf("%s ", &command[n]);
          fflush(stdout);
          set_cursor_position(cpos = add_cursor_pos(get_cursor_position(), -l-1));
        }
      }
      else
      {
        if(c == 13)
        {
          command[n+l] = c;
          command[n+l+1] = 0;
          putchar('\n');
          break;
        }
        else
        {
          memmove(&command[n+1], &command[n], l+1);
          command[n++] = c;
        }
        printf("%c%s", c, &command[n]);
        fflush(stdout);
        set_cursor_position(cpos = add_cursor_pos(get_cursor_position(), -l));
      }
    }
//    fflush(stdout);
  }
//  command[n] = 0;
}

unsigned get_cs(void);
#pragma aux get_cs = \
  "mov ax, cs" \
  value [ax];

int print_prompt(void)
{
  char *cwd = getcwd(0, 0xFF);
  if(!cwd) return 1;
  printf("%s>", cwd);
  free(cwd);
  fflush(stdout);
  return 0;
}

int main(int argc, char *argv[])
{
  char command[CMDLEN];
  unsigned n;
  int rc;
  unsigned char __far *machine_identification = MK_FP(0xF000, 0xFFFE);
  struct dosdate_t cmos_date;

  setenv("COMSPEC", argv[0], 1);
  command[0] = argv[0][0];
  command[1] = 0;
  setenv("COMDRV", command, 1);

  for(n=argc;n--;)
  {
    if(!istrncmp(&argv[n][strlen(argv[n])-4], dotbat, 4))
    {
      exit(run_batch(n, &argv[n], &rc));
    }
    if(!strcmp(argv[n], "/P"))
    {
      flags |= FLAG_PERM;
      if(*machine_identification <= 0xFC)
      {
        cmos_date = get_cmos_date();
        _dos_setdate(&cmos_date);
      }
      if(run_batch(0, autoexecbat, &rc))
      {
        show_date();
        show_time();
      }
    }
  }

  puts("ST-DOS command prompt v. 0.32");

//  _dos_setvect(0x23, MK_FP(get_cs(), break_handler));

  while(1)
  {
    if(print_prompt()) break;
    getcommand(command);
    if(*command >= ' ')
      if(parse_command(command, 0, 0, 0) == 1)
        break;
  }

  return errorlevel;
}
