#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>

int main(int argc, char *argv[])
{
  FILE *fp;
  int rc;
  unsigned int attr;

  if(argc < 3)
  {
    puts("Usage: >MKLINK [target] [link]");
    puts("Example: >MKLINK D:\\EXAMPLE\\DIR DIRLINK");
    return 1;
  }

  if(argv[1][strlen(argv[1])-1] != '\\')
  {
    if(argv[1][1] == ':' && !argv[1][2])
      puts("Warning: Target is a drive without a specified directory");
    else
    {
      fp = fopen(argv[1], "rb");
      rc = _dos_getfileattr(argv[1], &attr);
      if(!fp)
      {
        if(rc)
          puts("Warning: Target doesn't exist");
      }
      else
        fclose(fp);
    }
  }

  fp = fopen(argv[2], "w");
  if(!fp)
  {
    puts("Cannot create file");
    return 1;
  }
  if(fwrite(argv[1], strlen(argv[1]), 1, fp) != 1)
  {
    puts("Cannot write file");
    return 1;
  }
  fclose(fp);

  if((argv[1][1] == ':' && !argv[1][2]) || argv[1][strlen(argv[1])-1] == '\\')
    attr = _A_SUBDIR;
  else
  {
    rc = _dos_getfileattr(argv[1], &attr);
    if(rc)
    {
      attr = _A_NORMAL | _A_ARCH; // maybe a filesystem or a device file
    }
  }
  rc = _dos_setfileattr(argv[2], attr | 0x40);
  if(rc)
    printf("Error: %s\n", strerror(errno));

  return rc;
}
