#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int mount_syscall(void *str, void __far *drvname);
#pragma aux mount_syscall = \
  "mov ah, 0x6a" \
  "mov cx, 2" \
  "int 0x21" \
  "jnc end" \
  "mov ah, -1" \
  "end:" \
  value [ax] parm [di] [dx bx] modify [ax cx];

int unmount_syscall(void __far *str);
#pragma aux unmount_syscall =  \
  "mov ah, 0x6a" \
  "mov cx, 3" \
  "int 0x21" \
  "jnc end" \
  "mov ah, -1" \
  "end:" \
  value [ax] parm [dx bx] modify [ax cx];

int unmount(char *drive)
{
  int rc;
  char letter = *drive;
  *drive -= 'A';
  *drive &= 0x1F;
  rc = unmount_syscall(drive);
  if(rc >= 0)
    printf("Drive %c unmounted.\n", letter);
  else printf("Error %u\n",  rc & 0xFF);

  return rc & 0xFF;
}

int main(int argc, char *argv[])
{
  char *filename = argv[1];
  char *letter = argv[2];
  signed drive = 0;
  char syscallstruct[100];
  char type;
  unsigned block_size;
  unsigned long size;
  FILE *fp;

  if(argc < 4) 
  {
    if(argc == 2)
      return unmount(argv[1]);

    puts("Usage: > MOUNT [file] [target] [type] [fsdrivername]");
    puts("Types: [0 = FAT16] [1 = FAT12] [128 = use filesystem driver]");
    puts("To unmount: MOUNT [drive]");
    return 1;
  }

  drive = (*letter - 'A') & 0x1F;

  type = atoi(argv[3]);
  syscallstruct[0] = drive;
  syscallstruct[1] = type;
  strcpy(&syscallstruct[6], filename);
  if(argc < 5)
  {
    if(type & 0x80)
    {
      puts("Filesystem driver name required if (type & 0x80)...");
      return 1;
    }

    fp = fopen(filename, "rb");
    if(!fp)
    {
      puts("Could not open file");
      return 2;
    }
    fseek(fp, 11, SEEK_SET);
    if(fread(&block_size, 2, 1, fp) != 1)
    {
      error1:
      puts("Error while reading file");
      return 3;
    }
    fseek(fp, 19, SEEK_SET);
    if(fread(&size, 2, 1, fp) != 1)
      goto error1;

    printf("Block size: %u bytes, filesystem size: %u sectors\n", block_size, size);
  }
  else
  {
    size = -1;
  }
  *(unsigned long*)&syscallstruct[2] = size;

  drive = mount_syscall(syscallstruct, argv[4]);

  if(drive < 0)
  {
    printf("Error %u\n", drive & 0xFF);
    return 4;
  }

  printf("Mounted to drive %c\n", drive + 'A');

  return 0;
}
