#include <stdio.h>
#include <stdlib.h>
#include <direct.h>
#include <dos.h>
#include <string.h>
#include <fcntl.h>
#include <io.h>

#define _A_SYMLINK 0x40

unsigned depth = 0;

char target_dir[65];
char target_file[82];

unsigned char *copy_buff;
unsigned copy_count;
#define COPY_BUFF_SIZE 64*512;

unsigned flags = 0;
#define FLAG_E 0x01
#define FLAG_H 0x02

unsigned stdos_setfiletime(char *filename, unsigned time);
#pragma aux stdos_setfiletime = \
  "mov ax, 0x4302" \
  "int 0x21" \
  "jc end" \
  "xor ax, ax" \
  "end:" \
  parm [dx] [cx] value [ax];

unsigned stdos_setfiledate(char *filename, unsigned date);
#pragma aux stdos_setfiledate = \
  "mov ax, 0x4303" \
  "int 0x21" \
  "jc end" \
  "xor ax, ax" \
  "end:" \
  parm [dx] [cx] value [ax];


int copy_file(char *source, char *target)
{
  int srcfd, dstfd;
  char cannotopen[] = "Cannot open ";
  int bc;
  unsigned int attr;
  unsigned date, time;

  if(!_dos_getfileattr(target, &attr))
  {
    puts("Target already exists!");
    return 1;
  }

  srcfd = open(source, O_RDONLY | O_BINARY);
  if(srcfd == -1)
  {
    printf("%s%s\n", cannotopen, source);
    return 1;
  }

  _dos_getftime(srcfd, &date, &time);

  dstfd = open(target, O_WRONLY | O_TRUNC | O_CREAT | O_BINARY, S_IRWXU);
  if(dstfd == -1)
  {
    printf("%s%s\n", cannotopen, target);
    return 1;
  }

  while(bc = read(srcfd, copy_buff, copy_count))
  {
    if(bc == -1)
    {
      puts("Error while reading file");
      return 1;
    }
    if(write(dstfd, copy_buff, bc) != bc)
    {
      puts("Error while writing file");
      return 1;
    }
  }

  _dos_setftime(dstfd, date, time);

  close(srcfd);
  close(dstfd);

  _dos_getfileattr(source, &attr);
  _dos_setfileattr(target, attr);

  return 0;
}

int xcopy(char *filenames)
{
  struct find_t dirdta;
  struct find_t filedta;
  int rc;
  unsigned n;
  unsigned int attrib;
  char *dirptr;

  getcwd(target_file, sizeof(target_file));
  printf("Directory: %s\n", target_file);

  if(flags & FLAG_H) attrib = ~(_A_SUBDIR | _A_SYMLINK);
  else attrib = _A_NORMAL;
  rc = _dos_findfirst(filenames, attrib, &filedta);
  if(!rc) do
  {
    sprintf(target_file, "%s\\%s", target_dir, filedta.name);
    printf("Copy file %s to %s\n", filedta.name, target_file);
    if(copy_file(filedta.name, target_file))
      return 1;
  }
  while(!(rc = _dos_findnext(&filedta)));

  if(flags & FLAG_E)
  {  
    rc = _dos_findfirst("*.*", _A_SUBDIR, &dirdta);
    if(!rc) do
    {
      if((dirdta.attrib & _A_SUBDIR) && !(dirdta.attrib & _A_SYMLINK)
         && dirdta.name[0] != '.')
      {
        chdir(dirdta.name);
        depth++;
        sprintf(target_dir, "%s\\%s", target_dir, dirdta.name);
        if(mkdir(target_dir))
        {
          if(!(!_dos_getfileattr(target_dir, &attrib) && (attrib & _A_SUBDIR)))
          {
            printf("Cannot create %s\n", target_dir);
            return 1;
           }
        }
        else
          printf("Create directory %s\n", target_dir);
        if(stdos_setfiletime(target_dir, dirdta.wr_time))
          return 1;
        if(stdos_setfiledate(target_dir, dirdta.wr_date))
          return 1;
        if(xcopy(filenames))
          return 1;
        dirptr = strrchr(target_dir, '\\');
        *dirptr = 0;
      }
    }
    while(!(rc = _dos_findnext(&dirdta)));
  }
  
  if(depth)
  {
    chdir("..");
    depth--;
  }

  return 0;
}

int create_target(char *target, char *source)
{
  unsigned attr;
  int rc;
  struct find_t dta;

  if(!target[2] && target[1] == ':')
    return 0;

  rc = _dos_getfileattr(target, &attr);
  if(!rc)
  {
    if(!(attr & _A_SUBDIR))
    {
      printf("File %s already exists\n", target);
      return 1;
    }
    return 0;
  }
  else
  {
    rc = _dos_findfirst(source, _A_SUBDIR, &dta);
    if(rc || mkdir(target))
    {
      puts("Cannot create target directory");
      return 1;
    }
    stdos_setfiletime(target, dta.wr_time);
    stdos_setfiledate(target, dta.wr_date);
    return 0;
  }
}

void show_help(void)
{
  puts("Copies files and directory trees.");
  puts("Arguments:");
  puts("/E: Include subdirectories, also empty ones");
  puts("/H: Include hidden files");
  exit(0);
}

int parse_args(int argc, char *argv[], char **src, char **dst)
{
  unsigned n;
  for(n=1;n<argc;n++)
  {
    if(argv[n][0] == '/')
    {
      switch(argv[n][1] & 0x1F)
      {
        case ('?' & 0x1F):
          show_help();
        case ('E' & 0x1F):
          flags |= FLAG_E;
          break;
        case ('H' & 0x1F):
          flags |= FLAG_H;
          break;
      }
      continue;
    }
    if(!*src)
      *src = argv[n];
    else if(!*dst)
      *dst = argv[n];
    else return 1;
  }
  return 0;
}

void remove_trailing_chars(char *filename)
{
  unsigned l;
 
  while(l = strlen(filename))
  {
    l--;
    if(filename[l] == '\\' || filename[l] == '/')
      filename[l] = 0;
    else return;
  }
}

int main(int argc, char *argv[])
{
  unsigned l;
  char old_cwd[65];
  char *filenames;
  char allfiles[13] = "*.*";
  char *source = 0;
  char *target = 0;

  if(parse_args(argc, argv, &source, &target))
  {
    puts("Too many arguments");
    return 1;
  }

  if(argc < 3)
  {
    puts("Source and target required");
    return 1;
  }

  l = COPY_BUFF_SIZE;
  while(!(copy_buff = malloc(l)))
  {
    if(!(l -= 512))
    {
      puts("Out of memory");
      return 1;
    }
  }
  copy_count = l;

  strcpy(target_dir, target);

  remove_trailing_chars(source);
  if(!(!_dos_getfileattr(source, &l) && (l & _A_SUBDIR)))
  {
    filenames = strrchr(source, '\\');
    if(!filenames)
      filenames = strrchr(source, '/');
    if(*filenames)
      strcpy(allfiles, filenames+1);
  }
  printf("Copying files matching %s to %s\n", allfiles, target_dir);

  getcwd(old_cwd, sizeof(old_cwd));
  remove_trailing_chars(target_dir);

  if(target_dir[0] == '\\' || target_dir[0] == '/')
  {
    memmove(&target_dir[2], target_dir, strlen(target_dir));
    memcpy(target_dir, old_cwd, 2);
    goto change_target;
  }
  else if(/*target_dir[0] != '\\' && target_dir[0] != '/' && */target_dir[1] != ':')
  {
    memmove(&target_dir[strlen(old_cwd)+1], target_dir, strlen(target_dir));
    memcpy(target_dir, old_cwd, strlen(old_cwd));
    target_dir[strlen(old_cwd)] = '\\';
    change_target:printf("Changing target to %s\n", target_dir);
  }

  if(!create_target(target_dir, source))
  {
    if(source[1] == ':')
    {
      printf("Change drive to %c\n", source[0]);
      _dos_setdrive(source[0] & 0x1F, 0);
    }
    printf("Change directory to %s\n", source);
    chdir(source);

    xcopy(allfiles);
  }
  printf("Change drive to %c\n", old_cwd[0]);
  _dos_setdrive(old_cwd[0] & 0x1F, 0);
  printf("Change directory to %s\n", old_cwd);
  chdir(old_cwd);
  return 0;
}
