#include "globals.c"
#include "macros.c"

#define MAX_CONFIGSYS_LEN 1024

char __based(__segname("_CODE")) opening[] = "Opening config file\r\n";

char __based(__segname("_CODE")) ok[] = "...OK\r\n";
char __based(__segname("_CODE")) failed[] = "...unknown option\r\n";

char __based(__segname("_CODE")) optshell[] = "SHELL=";
char __based(__segname("_CODE")) optargs[] = "SHARGS=";
char __based(__segname("_CODE")) optdrv[] = "DRIVER=";
//char __based(__segname("_CODE")) drverr[] = "..error.\r\n";

extern char *errorstr;

char * __based(__segname("_CODE")) cfgfileopts[] =
{
  optshell
};

inline unsigned get_config_line(unsigned char __far *buff, unsigned char __far **dst)
{
  unsigned n = 0;
  *dst = buff;

  while(buff[n] >= ' ') n++;
  buff[n] = 0;

  return n;
}

inline int parse_config_lines(unsigned char __far *buff, int len)
{
  unsigned char __far *linebuff;
  unsigned opt;
  unsigned optlen;
  unsigned offset = 0;
  char __far *ptr;
  
  while(offset < len && buff[offset])
  {
    optlen = get_config_line(&buff[offset], &linebuff);
    offset += optlen + 1;
    if(!optlen) continue;

    if(!memcmp(linebuff, optargs, optlen = strlen(optargs)))
    {
      strcpy(SHELL_ARGS, &linebuff[optlen]);
      putstr(optargs);
      putstr(&linebuff[optlen]);
      putstr(ok);
      continue;
    }

    else if(!memcmp(linebuff, optdrv, optlen = strlen(optdrv)))
    {
      putstr(optdrv);
      putstr(&linebuff[optlen]);
      putstr(ok);
      if(ptr = strchr(&linebuff[optlen], ' '))
        *ptr++ = 0;
      else
        ptr = &linebuff[strlen(linebuff)];
      stshell_parse_args(ptr);
      load_shell(&linebuff[optlen], ptr);
      if(!error_code | CHILD_RC)
        putstr(ok);
      else
      {
        error_code = 0;
        putstr(failed);
      }
      defrag_memory();
      continue;
    }

    for(opt=sizeof(cfgfileopts)/sizeof(char*);opt--;)
    {  
      if(!memcmp(linebuff, cfgfileopts[opt], optlen = strlen(cfgfileopts[opt])))
      {
        strcpy(CONFIG_FNOPT(opt), &linebuff[optlen]);
        putstr(cfgfileopts[opt]);
        putstr(CONFIG_FNOPT(opt));
        putstr(ok);
        break;
      }
    }
    if(opt == -1)
    {
      putstr(linebuff);
      putstr(failed);
    }
  }

  return 0;
}

void parse_config(dirindex_t index)
{
  dirindex_t file_index[3];
  unsigned buff_seg;;
  int rc;
  unsigned char __far *buff;

  buff_seg = allocate_high(MAX_CONFIGSYS_LEN>>4, 0);
  
  if(!buff_seg)
    return; // Out of memory, todo: implement error message

  buff = MK_FP(buff_seg, 0);

  memset(buff, 0, MAX_CONFIGSYS_LEN);

  memory_integrity_check();
  
  file_index[0] = SYSTEM_DRIVE;
  file_index[1] = index;
  file_index[2] = -1;

  putstr(opening);
  
  if(rc = read_file(0, file_index, MAX_CONFIGSYS_LEN, buff, 0))
    rc = parse_config_lines(buff, rc);
  if(error_code || rc)
    putstr(errorstr);

  memory_integrity_check();

  delete_alloc(buff_seg);

  memory_integrity_check();
}

