#include "globals.c"
#include "macros.c"
#include "structs.c"

#define ENVIRONMENT_SIZE 2048

int add_env_progname(unsigned env_block, char __far *progname, unsigned env_size)
{
  unsigned char __far *env_ptr = MK_FP(env_block, 0);
  unsigned l;
  unsigned e = 0;
  unsigned i = 0;

  if(!CURRENT_PSP)
  {
    // empty environment
//    *env_ptr++ = 0x00;
//    *env_ptr++ = 0x00;
    // optimization
    *(unsigned short __far*)env_ptr = 0x0000;
    i=2;
  }
  else
  {
    // find the end of environment
    while(l = strlen(&env_ptr[i]))
    {      
      if(i+l+1 > env_size - 86) // invalid environment variable, or full environment
      {
        error_code = 0x0A;
        return -1; 
      }
      i += l+1;
      e++;
    }
    // if the old environment was empty, jump over the additional null byte
    if(!e)
      i++;

    env_ptr[i++] = 0; 
  }

  // now env_ptr points to count of additional strings
  *(unsigned short __far*)&env_ptr[i] = 1;

  i+=2;

  env_ptr[i++] = WORKING_DRIVE + 'A';
  env_ptr[i++] = ':';
  env_ptr[i++] = '\\';
  l = directory_path(&env_ptr[i], WORKING_DRIVE);
  i += l;
  if(l) env_ptr[i++] = '\\';
  strcpy(&env_ptr[i], progname);
  // append one null character
  i += strlen(&env_ptr[i]) + 1;
  env_ptr[i] = 0;

  return 0;
}

inline unsigned calc_env_size(unsigned char __far *env_ptr)
{
  unsigned retval=0;
  do
  {
    if(!*(unsigned short __far*)&env_ptr[retval])
    {
      retval += 86;
      if(retval < 86) break;
      else return retval;
    }
  }
  while(++retval);
  return 0;
}

int allocate_env_block(char __far *progname, unsigned old_env_seg)
{
  unsigned char __far *new_env_ptr;
  unsigned char __far *old_env_ptr = 0;
  unsigned env_size = ENVIRONMENT_SIZE>>4;
  unsigned env_seg;

  if(CURRENT_PSP)
  {
    if(!old_env_seg)
      old_env_seg = ENVIRONMENT_SEG(CURRENT_PSP);

    old_env_ptr = MK_FP(old_env_seg, 0);
    if(mcb_exists(old_env_seg-=MCB_PARAGRAPHS))
      env_size = PARAGRAPH_COUNT(old_env_seg);
    else
      env_size = calc_env_size(old_env_ptr);
  }

  env_seg = new_alloc(env_size, 1);
  if(!env_seg) return 0;

  new_env_ptr = MK_FP(env_seg, 0);

  env_size <<= 4;

  if(old_env_ptr)
    memcpy(new_env_ptr, old_env_ptr, env_size);

  if(add_env_progname(env_seg, progname, env_size))
  {
    free_alloc(env_seg);
    return 0;
  }

  return env_seg;
}
