#include "globals.c"
#include "macros.c"

#define TIMEOUT TICKS_PER_SECOND*2
#define FDSPIN_TIMEOUT TICKS_PER_SECOND>>2

unsigned long clock_ticks();
#pragma aux clock_ticks = \
  "push ax" \
  "xor ah, ah" \
  "int 0x1A" \
  "pop ax" \
  value [cx dx];

void device_wait(unsigned char type_code);
#pragma aux device_wait parm [ax] modify exact [];

void device_wait(unsigned char type_code)
{
  unsigned long start_time = clock_ticks();
  unsigned timeout;
  if(type_code >= 0xC0) timeout = FDSPIN_TIMEOUT;
  else timeout = TIMEOUT;

  while(!((volatile unsigned char)INT15_INTERRUPT))
  {
    call_idle_handler();
    if(clock_ticks() - start_time > timeout)
    {
      INT15_INTERRUPT=0;
      break;
    }
  }
}

void set_int15h_handler(void)
{
  bios_int15_handler = get_vector(0x15);
  set_near_vector(0x15, int15h_handler);
}
