#include "globals.c"
#include "macros.c"
#include "structs.c"

char __based(__segname("_CODE")) console_filename[] = "CON";

unsigned int21c3d(unsigned, char __far*);
#pragma aux int21c3d parm [ax] [es dx] value [ax] modify exact [];

int open_dev(unsigned access_mode, unsigned devseg, unsigned partition, unsigned devnum)
{
  int rc;
  unsigned dev;
  if(devseg == -1) // partition
  {
    access_mode |= 0x8000;
    dev = partition;
  }
  else // device driver
  {
    if(driver_open(devseg, devnum, (access_mode & 0x03)-1))
    {
      error_code = 0x05;
      return -1;
    }
    access_mode |= 0x4000;
    dev = devseg;
  }
  rc = new_handle(CURRENT_PSP, access_mode);
  if(rc >= 0)
    handle_dev(rc, dev, devnum);
  else
    error_code = 0x04;
  return rc;
}

unsigned int21c3d(unsigned access_mode, char __far *filename)
{
  int rc;
  unsigned devseg;
  unsigned devnum;
  unsigned partition;
  dirindex_t index;
  dirindex_t old_dir[MAX_DIR_DEPTH+2];

  access_mode >>= 8;
  access_mode &= 0x03;
  access_mode++;

  if(!cistrncmp(filename, console_filename, 12))
  {
    rc = new_handle(CURRENT_PSP, 0);
    if(rc >= 0) return rc;
    error_code = 0x04; // no memory
  }
  else if((devseg = is_driver_name(filename, &partition, &devnum))
          && devnum != -1)
  {
    if(!error_code)
      dev_open:return open_dev(access_mode, devseg, partition, devnum);
  }
  else
  {
    filename = chg2filedir(filename, old_dir);
    if(!error_code)
    {
      index = get_file_index(WORKING_DRIVE, filename, old_dir);
      if(!error_code)
      {
        rc = new_handle(CURRENT_PSP, access_mode);
        if(rc >= 0)
          handle_file(rc, index, 0);
        else
          error_code = 0x04;
      }
      chg2olddir(old_dir);
      if(error_code == ERR_IS_SYMLINK)
      {
        devseg = index;
        if(devseg != -1)
          devnum = index >> 16;
        else
          partition = index >> 16;
        error_code = 0;
        goto dev_open;
      }
    }
  }

  return rc;
}
