#define FP_OFF(ptr) ((unsigned short)ptr)
#define FP_SEG(ptr) ((unsigned short)((unsigned long)ptr >> 16))
#define MK_FP(seg, off) ((void __far*)((((unsigned long)seg) << 16) | off))

#define ERR_DISKFULL 0x60
#define ERR_IS_SYMLINK 0x60

#define MCB_PARAGRAPHS ((sizeof(struct mcb)+0xF)>>4)

#define FIRST_ALLOC_PARAGRAPHS 0x30

#define PARAGRAPH_COUNT(mcbseg) (((struct mcb __far*)MK_FP(mcbseg, 0))->paragraph_count)
#define NEXT_MCB(mcbseg) (((struct mcb __far*)MK_FP(mcbseg, 0))->next_mcb_seg)
#define PREV_MCB(mcbseg) (((struct mcb __far*)MK_FP(mcbseg, 0))->prev_mcb_seg)
#define OWNER_PSP(mcbseg) (((struct mcb __far*)MK_FP(mcbseg, 0))->owner_psp)
#define MCB_TYPE(mcbseg) (((struct mcb __far*)MK_FP(mcbseg, 0))->type)
#define MCB_UCACHEPTR(mcbseg) (((struct mcb __far*)MK_FP(mcbseg, 0))->usercache_freedptr)

#define PARENT_PSP(psp) *(unsigned __far *)MK_FP(psp, 0x16)
#define OLD_INT22_HDLR(psp) *(void __far* __far*)MK_FP(psp, 0x0A)
#define OLD_BREAK_HDLR(psp) *(void __far* __far*)MK_FP(psp, 0x0E)
#define OLD_CRITERR_HDLR(psp) *(void __far* __far*)MK_FP(psp, 0x12)
#define LAST_PARAGRAPH(psp) *(unsigned __far *)MK_FP(psp, 0x02)
#define PSP_SEGMENT_SIZE(psp) *(unsigned __far*)MK_FP(psp, 0x06)
#define RETURN_INT(psp) *(unsigned __far*)MK_FP(psp, 0)
#define ENVIRONMENT_SEG(psp) *(unsigned __far*)MK_FP(psp, 0x2C)
#define PSP_DOS_VERSION(psp) *(unsigned __far*)MK_FP(psp, 0x40)
#define FARCALL_ENTRY(psp) *(unsigned __far*)MK_FP(psp, 0x50)

#define TERMINATE_ADDRESS *(void __far* __far*)MK_FP(SYSCALL_SS(CURRENT_PSP), SYSCALL_SP(CURRENT_PSP)+6)

#define PREV_READ_SECTOR(drive) ((struct partition __far*)MK_FP(PARTITION_SEG[drive], 0))->prev_read_sector

#define DISK_CACHE ((struct cache_entry *)cache_seg)
#define MAX_SECTOR_SIZE 512
#define HD_SECTOR_SIZE 512

#define KERNEL_ONLY_MEM (4*MAX_SECTOR_SIZE+512)

//#define CACHE_SIZE 128
#define RAW_CACHES ((1024*9)>>4)

#define DIRINDEX_READ_ENTRIES 64

#define DEFAULT_BUFFER_SIZE 65535

#define MAX_SYMLINKS 8

#define PRINTNUM(x) putstr(hex2str(x))

// disable LBA?
//#define DISABLE_LBA
// fill allocated clusters with zero?
//#define ZERO_ALLOCATED_CLUSTERS

#include "farptr.c"

unsigned __far call_int24h_wrapper(unsigned di, unsigned ax);
#pragma aux call_int24h_wrapper parm [di] [ax] value [ax];

#define BRK_FLAG 0x01
#define IN_KERNEL_FLAG 0x02
#define BREAK_SENSE_FLAG 0x04
#define BREAK_DETECTED 0x08

#define MEMALLOC_STRATEGY_FIRST 0x00
#define MEMALLOC_STRATEGY_LAST 0x10
#define MEMALLOC_STRATEGY_BESTFIT 0x20

#define MEMALLOC_STRATEGY_KEEPTOPFREE 0x40

#define MEMALLOC_TOPSIZE (MAX_SECTOR_SIZE>>4)

#define CRITERR_WRITING 0x01
#define CRITERR_READING 0x00
#define CRITERR_SYSTEMFILES 0x00
#define CRITERR_FILESYSTEM (0x01 << 1)
#define CRITERR_DIRECTORY (0x02 << 1)
#define CRITERR_DATAAREA (0x03 << 1)
#define CRITERR_DISK 0x00
#define CRITERR_DEVICE 0x80
#define CRITERR_ALLOW_FAIL 0x08
#define CRITERR_ALLOW_RETRY 0x10
#define CRITERR_ALLOW_IGNORE 0x20 
#define CRITERR_ALLOW_ABORT 0x40

#define CRITERR_RETRY 1
#define CRITERR_IGNORE 0
#define CRITERR_ABORT 2
#define CRITERR_FAIL 3

void terminate_application(void);
#pragma aux terminate_application = \
  "int 0x23";

unsigned get_code_segment(void);
#pragma aux get_code_segment = \
  "mov ax, cs" \
  value [ax] modify exact [ax];
#define CODE_SEGMENT get_code_segment()

unsigned get_data_segment(void);
#pragma aux get_data_segment = \
  "mov ax, ds" \
  value [ax] modify exact [ax];

unsigned get_stack_pointer(void);
#pragma aux get_stack_pointer =  \
  "mov ax, sp" \
  value [ax] modify exact [ax];

void set_data_segment(unsigned segment);
#pragma aux set_data_segment = \
  "mov ds, ax" \
  parm [ax];

void halt(void);
#pragma aux halt = \
  "cli" \
  "hlt";

void disable(void);
#pragma aux disable = \
  "cli";

void enable(void);
#pragma aux enable = \
  "sti";

//#define XCHG(u) (u << 8) | (u >> 8)
unsigned XCHG(unsigned);
#pragma aux XCHG = \
  "xchg ah, al" \
  parm [ax] value [ax] modify exact [ax];

unsigned abs(int);
#pragma aux abs = \
  "test ah, 0x80" \
  "jnz abs_end" \
  "not ax" \
  "inc ax" \
  "abs_end:" \
  parm [ax] value [ax] modify exact [ax];

#ifdef USE_32BIT
void *mmx_store_fpu(void);
#pragma aux mmx_store_fpu = \
  "sub sp, 94" \
  "mov bx, sp" \
  "fsave [bx]" \
  value [bx];

void mmx_restore_fpu(void *ptr);
#pragma aux mmx_restore_fpu = \
  ".586" \
  ".MMX" \
  "emms" \
  "frstor [bx]" \
  parm [bx];

unsigned long long b32_lba_addl(unsigned long long const __far *, unsigned long const *);
#pragma aux b32_lba_addl = \
  ".386" \
  "mov eax, es:[di]" \
  "mov edx, es:[di+4]" \
  "add eax, [bx]" \
  "adc edx, 0" \
  "mov cx, ax" \
  "mov bx, dx" \
  "shr eax, 16" \
  "shr edx, 16" \
  "xchg cx, ax" \
  "xchg ax, dx" \
  value [ax bx cx dx] parm [es di] [bx];

void b32_lba_adds(unsigned long long const*, unsigned const*);
#pragma aux b32_lba_adds = \
  ".386" \
  "mov eax, [di]" \
  "mov edx, [di+4]" \
  "mov bx, [bx]" \
  "and ebx, 0xFFFF" \
  "add eax, ebx" \
  "adc edx, 0" \
  "mov [di], eax" \
  "mov [di+4], edx" \
  parm [di] [bx] modify [ax dx bx];
  

void b32_llsub(unsigned long long const*, unsigned long long const*);
#pragma aux b32_llsub = \
  ".386" \
  "mov eax, [di]" \
  "mov edx, [di+4]" \
  "sub eax, [bx]" \
  "sbb edx, [bx+4]" \
  "mov [di], eax" \
  "mov [di+4], edx" \
  parm [di] [bx] modify [ax dx];

unsigned char b32_lleq(unsigned long long const* n1, unsigned long long const* n2);
#pragma aux b32_lleq = \
  ".386" \
  "mov eax, [di]" \
  "sub eax, [bx]" \
  "jne not_equal" \
  "mov eax, [di+4]" \
  "sub eax, [bx+4]" \
  "je end" \
  "not_equal:" \
  "mov al, 1" \
  "end:" \
  value [al] parm [di] [bx] modify [ax];

unsigned char b32_llgt(unsigned long long const* n1, unsigned long long const* n2);
#pragma aux b32_llgt = \
  ".386" \
  "mov eax, [di+4]" \
  "cmp eax, [bx+4]" \
  "ja is_greater" \
  "mov eax, [di]" \
  "cmp eax, [bx]" \
  "jbe not_greater" \
  "is_greater:" \
  "mov al, 1" \
  "jmp end" \
  "not_greater:" \
  "xor al, al" \
  "end:" \
  value [al] parm [di] [bx] modify [ax];

#endif

inline int is_path_separator(char chr)
{
  if(chr == '\\' || chr == '/')
    return 1;
  return 0;
}

inline unsigned char __far *find_path_separator(char __far *str)
{
  unsigned char __far *retval;
  if(retval = strchr(str, '\\'))
    return retval;
  return strchr(str, '/');
}

unsigned long mul_16to32(unsigned n1, unsigned n2);
#pragma aux mul_16to32 = \
  "mul dx" \
  parm [ax] [dx] value [dx ax];

unsigned long longdiv(unsigned long, unsigned);
#pragma aux longdiv = \
  "div bx" \
  parm [dx ax] [bx] value [ax dx];

#define LONGDIV(a, b) (longdiv(a, b) & 0xFFFF)
#define LONGMOD(a, b) (longdiv(a, b) >> 16)

#define DOS_VERSION 5
#define DOS_MINOR_VERSION 0
#define OEM_ID (unsigned)0x57
#define REVISION 0x000032L

#ifdef __SW_0
#define REVISION_SEQ (unsigned long)REVISION
#endif
#ifdef __SW_1
#define REVISION_SEQ (unsigned long)(REVISION | 0x100000L)
#endif
#ifdef __SW_2
#define REVISION_SEQ (unsigned long)(REVISION | 0x200000L)
#endif
#ifdef __SW_3
#define REVISION_SEQ (unsigned long)(REVISION | 0x300000L)
#endif
#ifdef __SW_4
#define REVISION_SEQ (unsigned long)(REVISION | 0x400000L)
#endif
#ifdef __SW_5
#define REVISION_SEQ (unsigned long)(REVISION | 0x500000L)
#endif
#ifdef __SW_6
#define REVISION_SEQ (unsigned long)(REVISION | 0x600000L)
#endif

#define DRIVE_REMOVABLE_BIT 0x01
#define DRIVE_FLOPPY_BIT 0x02
#define SAVE_CACHE_BIT 0x04
#define PARTITION_BIT 0x08

#define MAX_FLOPPY_COUNT 4
#define FLOPPY_COUNT_R (FLOPPY_COUNT + (FLOPPY_COUNT & 1))

// dynamic kernel variables start here
extern unsigned char code_end[];
#define initial_mcb_off ((unsigned char *)(FP_OFF(code_end)))

// system drive
#define SYSTEM_DRIVE initial_mcb_off[0]

#define FLOPPY_COUNT initial_mcb_off[1]

#define FILE_BUFFER_SIZE *(unsigned *)&initial_mcb_off[2]

#define CURRENT_PSP *(unsigned*)&initial_mcb_off[4]
#define PROGRAM_SP *(unsigned*)&initial_mcb_off[6]
#define PROGRAM_SS *(unsigned*)&initial_mcb_off[8]

#define HARD_DISK_COUNT *(unsigned char __far*)MK_FP(0x40, 0x75)

#define DRIVE_STRUCT_SIZE 6

#define DRIVE_TABLE (*(unsigned *)&initial_mcb_off[10])
#define DRIVE_TABLE_ARR ((unsigned char __far*)MK_FP(DRIVE_TABLE, 0))
#define DRIVE_SECTOR_SIZE(n) ((DRIVE_TABLE_ARR[n*DRIVE_STRUCT_SIZE] >> 4) << 8)
#define DRIVE_SECTORS(n) DRIVE_TABLE_ARR[n*DRIVE_STRUCT_SIZE+1]
#define DRIVE_LAST_CYL(n) (*(unsigned __far*)&DRIVE_TABLE_ARR[n*DRIVE_STRUCT_SIZE+2])
#define DRIVE_MIN_RAWBUFF_SECTORS(n) (*(unsigned char __far*)&DRIVE_TABLE_ARR[n*DRIVE_STRUCT_SIZE+4])
#define DRIVE_HEADS(n) DRIVE_TABLE_ARR[n*DRIVE_STRUCT_SIZE+5]

#define rawcache_size (*(unsigned*)&initial_mcb_off[44])
inline void SAVE_DRIVE_SECTOR_SIZE(unsigned drive, unsigned sector_size)
{
  DRIVE_TABLE_ARR[drive*DRIVE_STRUCT_SIZE] &= 0x0F;
  DRIVE_TABLE_ARR[drive*DRIVE_STRUCT_SIZE] |= (sector_size >> 8) << 4;
  DRIVE_MIN_RAWBUFF_SECTORS(drive) = rawcache_size / sector_size;
}

#define IS_FLOPPY(drive) ((DRIVE_TABLE_ARR[drive*DRIVE_STRUCT_SIZE]) & DRIVE_FLOPPY_BIT)
#define IS_REMOVABLE(drive) ((DRIVE_TABLE_ARR[drive*DRIVE_STRUCT_SIZE]) & DRIVE_REMOVABLE_BIT)
#define IS_PARTITIONED(drive) ((DRIVE_TABLE_ARR[drive*DRIVE_STRUCT_SIZE]) & PARTITION_BIT)

#define FIRST_DRIVER *(unsigned *)&initial_mcb_off[12]

#define DTA_ID (*(unsigned *)&initial_mcb_off[14])
#define CACHE_SIZE *(unsigned *)&initial_mcb_off[16]

// use per-process DTA buffer
#define DTA_BUFFER (*(unsigned char __far* __far*)MK_FP(CURRENT_PSP, 0x3C))
#define CURRENT_DTA_ID (*(unsigned __far*)DTA_BUFFER)

#define SYSCALL_SS(psp) (*(unsigned __far*)MK_FP(psp, 0x30))
#define SYSCALL_SP(psp) (*(unsigned __far*)MK_FP(psp, 0x28))

#define HD_DYNPART_COUNT (*(unsigned*)&initial_mcb_off[18])

#define CHILD_RC *(unsigned*)&initial_mcb_off[20]

#define LAST_MCB *(unsigned*)&initial_mcb_off[22]

#define AVAILABLE_MEMORY *(unsigned*)&initial_mcb_off[24]

#define WORKING_DRIVE initial_mcb_off[26]

#define INDOS_FLAG initial_mcb_off[27]

#define BREAKINT_HDLR_SP *(unsigned*)&initial_mcb_off[28]

#define INT15_BUSY_DEVICE initial_mcb_off[30]
#define INT15_INTERRUPT initial_mcb_off[31]

#define SYMLINK_RECURSION_COUNT initial_mcb_off[32]
#define DONT_FLUSH_CACHES initial_mcb_off[33]

#define SYSCALL_RETFLAGS *(unsigned*)&initial_mcb_off[34]

#define KERNEL_SP *(unsigned*)&initial_mcb_off[36]
#define DRVCALL_PSP *(unsigned *)&initial_mcb_off[38]

#define DYNFLAGS initial_mcb_off[40]
#define VERIFY_BIT 0x01
#define VERIFY_FLAG (DYNFLAGS & VERIFY_BIT)
/*
  This flag prevents the get_disk_parm() function from invalidating caches.
  This flag is set to 1 by the write_to_cache() function.
*/
#define WRITE_BIT 0x02
#define WRITE_FLAG (DYNFLAGS & WRITE_BIT)

#define RAWCACHE_SAVED_BIT 0x04
#define RAWCACHE_SAVED !(DYNFLAGS & RAWCACHE_SAVED_BIT)

#define CRITERR_HDL_BIT 0x08
#define IN_CRITERR_HDL (DYNFLAGS & CRITERR_HDL_BIT)

#define weekday initial_mcb_off[41]

#define rawcache_buff (*(unsigned char **)&initial_mcb_off[42])

#define rawcache_size (*(unsigned*)&initial_mcb_off[44])
#define cache_size (*(unsigned*)&initial_mcb_off[46])
#define cache_seg (*(void**)&initial_mcb_off[48])

#define buffers (*(unsigned*)&initial_mcb_off[50])

#define extended_error_code *(unsigned*)&initial_mcb_off[52]

#define error_class initial_mcb_off[54]
#define suggested_action initial_mcb_off[55]
#define error_locus initial_mcb_off[56]
#define internal_flags initial_mcb_off[57]

#define INT15_SP *(unsigned*)&initial_mcb_off[58]
#define INT15_SS *(unsigned*)&initial_mcb_off[60]

#define RAWCACHE_LAST_SECTOR *(lbaindex_t*)&initial_mcb_off[62]
#define RAWCACHE_LAST_DISK initial_mcb_off[70]
#define RAWCACHE_LAST_SECTOR_COUNT initial_mcb_off[71]

#define saved_cache_seg (*(void **)&initial_mcb_off[72])

#define ALT_DPT (&initial_mcb_off[74])

#define CONINPUT_BUFFER_SIZE 128

#define DYNVARS_LEN 74+11

#define CONINP_BUFF (&initial_mcb_off[DYNVARS_LEN])

#define BOOT_PARTITION_OFFSET *(unsigned long *)CONINP_BUFF

#define PARTITION_SEG ((unsigned*)&initial_mcb_off[DYNVARS_LEN+CONINPUT_BUFFER_SIZE])
#define MAX_PARTITIONS 25

// byte count of dynamic variables
#define DYNVAR_BC DYNVARS_LEN+(sizeof(unsigned)*MAX_PARTITIONS)+CONINPUT_BUFFER_SIZE
// todo: integer-length config variables...

  
// filename-length config variables, for parsing CONFIG.SYS
#define CONFIG_FNOPT(opt) (char*)(initial_mcb_off + DYNVAR_BC + opt*(13+0x80))
  
// for accessing
#define CFG_SHELL CONFIG_FNOPT(0)

// args for shell (can be 0x80 chars long)
#define SHELL_ARGS (CFG_SHELL+strlen(CFG_SHELL)+1)

#define MAX_DIR_DEPTH 6
#define FILENAME_LEN 13
#define MAX_PATH 82

#define ATTR_DIR 0x10
#define ATTR_HIDDEN 0x02
#define ATTR_SYSTEM 0x04
#define ATTR_LABEL 0x08
#define ATTR_ARCHIVE 0x20
#define ATTR_RDONLY 0x01
#define ATTR_SYMLINK 0x40

#define TICKS_PER_HOUR 65544
#define TICKS_PER_MINUTE 1093
#define TICKS_PER_SECOND 18


