.8086

.MODEL large

PUBLIC memcpyr_
PUBLIC nmemcpyr_
PUBLIC memcpy_
PUBLIC nmemcpy_
PUBLIC strlen_
PUBLIC memset_
PUBLIC nmemset_
PUBLIC memcmp_
PUBLIC memchr_

_TEXT               SEGMENT BYTE PUBLIC USE16 'CODE'
                ASSUME CS:_TEXT                               

nmemcpyr_ proc near
  push cx
  push ds
  push di
  push si
  jmp memcpyr
nmemcpyr_ endp

memcpyr_ proc near
  push cx
  push ds
  mov ds, dx
  push di
  push si
  memcpyr:
  std

  add di, cx
  add si, cx

  test cl, 0x01
  jz copy_words_r

  dec cx
  dec di
  dec si
  movsb
  dec di
  dec si
  jmp copy_words_r2

  copy_words_r:

  sub di, 2
  sub si, 2
  copy_words_r2:
  shr cx, 1
  rep movsw

  pop si
  pop di
  pop ds
  pop cx
  ret
memcpyr_ endp

; dx:si = source, es:di = destination, cx = count
memcpy_ proc near
  push cx
  push ds
  mov ds, dx
  push di
  push si
  memcpy:
  cld

  test cl, 0x01
  jz copy_words ; if even count, copy only words
  ; else copy the last byte

  dec cx

  add di, cx
  add si, cx
  movsb
  inc cx
  sub di, cx
  sub si, cx
 
  copy_words:
  shr cx, 1
  rep movsw

  pop si
  pop di
  pop ds
  pop cx
  ret  
memcpy_ endp

nmemcpy_ proc near
; si = source, es:di = destination, cx = count
  push cx
  push ds
  push di
  push si
  jmp memcpy
nmemcpy_ endp

nmemset_ proc near
  push ax
  push cx
  push di
  push ds
  pop es
  jmp memset
nmemset_ endp

; es:di = destination, al = set byte, cx = count
memset_ proc near
;  pushf
  push ax
  push cx
  push di
  memset:
  cld

  test cl, 0x01
  jz set_words

  dec cx
  add di, cx  
  stosb
  inc cx
  sub di, cx
  
  set_words:
  mov ah, al
  shr cx, 1
  rep stosw

  pop di
  pop cx
  pop ax
;  popf
  ret
memset_ endp

; es:di = pointer to string
strlen_ proc near
;  pushf
  cld
  push cx

; find null byte  
  mov cx, 0xFFFF
  sub cx, di
  xor al, al
  push di
  repne scasb

  mov ax, di
  dec ax
  pop di
; string length == ax - di
  sub ax, di

  pop cx
;  popf
  ret
strlen_ endp

; es:di, dx:si == buffers to compare
; cx = byte count
; return value to cx
memcmp_ proc near
  push ds
  push di
  push si
  mov ds, dx
  cld

  test cl, 1
  jz memcmp_words

  dec cx
  add di, cx
  add si, cx
  cmpsb ; if zf not set, last bytes differ
  jnz memcmp_diff
  inc cx
  sub di, cx
  sub si, cx

  memcmp_words:
  shr cx, 1
  repe cmpsw
  jnz memcmp_diff

  memcmp_end:
  pop si
  pop di
  pop ds
  ret

  memcmp_diff:
  or cx, 1
  jmp memcmp_end  
memcmp_ endp

; al = chr, es:di = buffer, cx = count
memchr_ proc near
  push cx
  cld

  repne scasb
  jz memchr_found

  xor di, di
  mov es, di
  jmp memchr_end

  memchr_found:
  dec di

  memchr_end:
  pop cx
  ret
memchr_ endp
_TEXT ENDS

END


