#include "globals.c"
#include "macros.c"

// arguments: string 1, string 2, pointer to max length
// return non-zero if string lengths are different
// or zero when strings are longer than max length
// if string lengths are equal, update string length to *count
static int lencmp(char __far *str0, char __far *str1, unsigned *count)
{
  unsigned l0 = strlen(str0);
  unsigned l1 = strlen(str1);
  register int r;

  if(l0 < *count && l1 < *count)
  {
    r = l0 - l1;
    if(!r)
      *count = l0;
    return r;
  }
  else if(l0 < *count || l1 < *count)
  {
    return 1;
  }
  return 0;
}

int strncmp(char __far *str0, char __far *str1, unsigned count)
{
//  unsigned l0 = strlen(str0);
//  unsigned l1 = strlen(str1);
  register int r;

/*  if(l0 < count && l1 < count)
  {
    r = l0 - l1;
    if(!r)
      count = l0;
    else
      return r;
  }
  else if(l0 < count || l1 < count)
  {
    return 1;
  }*/
  r = lencmp(str0, str1, &count);

  if(!r)
    return memcmp(str0, str1, count);
  return r;
}

char toupper(char chr)
{
  if(chr >= 'a' && chr <= 'z')
    return chr & ~0x20;
  return chr;
}

int cistrncmp(char __far *str0, char __far *str1, unsigned count)
{
  register char r;

  r = lencmp(str0, str1, &count);

  if(!r)
    while(!(r = toupper(*str0) - toupper(*str1)) && --count)
    {
      str0++;
      str1++;
    }

  return r;
}

/*char __far *memtoupper(char __far *str, unsigned count)
{
  char __far *retval = str;
  while(count--)
  {
    if(*str >= 'a' && *str <= 'z')
      *str++ &= ~0x20;
  }
  return retval;
}

char __far *strtoupper(char __far *str)
{
  return memtoupper(str, strlen(str));
}*/

// replace the first trailing character from a string by 0
// and return the trailing character for re-inserting it later
/*unsigned char rtchars(unsigned char __far *str)
{
  unsigned char retval;
  while(*str >= ' ')
    str++;

  retval = *str;

  *str = 0;

  return retval;
}*/

char __far *strpbrk(char __far *str0, char __far *str1)
{
  while(*str0)
    if(strchr(str1, *str0))
      return str0;
    else
      str0++;

  return 0;
}

/*char __far *strchr(unsigned char __far *str, unsigned char chr)
{
  do
    if(*str == chr) return str;
  while(*str++);
  return 0;
}*/

/*char __far *strcat(char __far *dst, char __far *src)
{
  dst += strlen(dst);
  strcpy(dst, src);
}*/
