#include "globals.c"
#include "macros.c"

//char __based(__segname("_CODE")) shell_error[] = "Default shell not found.\r\n";
char __based(__segname("_CODE")) kernel_prompt[] = "KERNEL>";
char __based(__segname("_CODE")) unknowncommand[] = "?\r\n";
char __based(__segname("_CODE")) nomemory[] = "Out of memory\r\n";

inline void kernel_command_line(void)
{
  char *command = CFG_SHELL;
  char *filename_end;

  error_code = 0;
  putstr(kernel_prompt);
  *(unsigned *)&command[getstr(13+0x7F, command)] = 0;
  filename_end = (char __near*)istrchr(command, ' ');
  if(filename_end)
    *filename_end = 0;
}

void stshell_parse_args(char __far *args)
{
  unsigned l = strlen(args);

  args[l+1] = 0x0D;

  memcpyr(&args[1], &args[0], l);

  args[0] = l;
}

void start_shell(void);
#pragma aux start_shell aborts;

void start_shell(void)
{
  int rc;

  set_int15h_handler();
  while(1)
  {
    stshell_parse_args(SHELL_ARGS);
    if(*CFG_SHELL && (rc = load_shell(CFG_SHELL, SHELL_ARGS)))
    {
      switch(error_code)
      {
        case 0x08: putstr(nomemory); break;
        default: putstr(CFG_SHELL); putstr(unknowncommand);
      }
    }
    kernel_command_line();
  }
}
