#include "globals.c"
#include "macros.c"

int get_symlink_path(dirindex_t link, dirindex_t *index, unsigned char attr, unsigned *type, dirindex_t *old_dir)
{
  char path[MAX_PATH];
  char *pathptr;
  int rc;
  int drive;
  int retval;
  dirindex_t full_path[MAX_DIR_DEPTH+2];
  dirindex_t old_dir_2[MAX_DIR_DEPTH+2];

  if(SYMLINK_RECURSION_COUNT == MAX_SYMLINKS)
  {
    error_code = 0x54;
    return -1;
  }

  if(get_stack_pointer() < 0x200)
    return -1;

  full_path[0] = WORKING_DRIVE;
  rc = getcwd(full_path[0], &full_path[1]);
  full_path[rc] = link;
  full_path[rc+1] = -1;
  rc = read_file(0, full_path, MAX_PATH-1, path, 0);

  if(!rc || error_code)
    return -1;

  path[rc] = 0;

  if(type && (rc = is_driver_name(path, (unsigned*)&drive, (unsigned*)&retval)))
  {
    if(error_code) return -1;
    *type = (unsigned)rc;
    if(*type == -1) // partition
      *index = (unsigned)drive;
    else
      *index = (unsigned)retval;
    return 0;
  }

  SYMLINK_RECURSION_COUNT++;

  if(attr & ATTR_DIR)
  {
    old_dir_2[0] = WORKING_DRIVE;
    getcwd(WORKING_DRIVE, &old_dir_2[1]);
    if(change_file_drive(path) == -1)
      retval = -1;
    else
    {
      if(old_dir_2[0] != WORKING_DRIVE)
      {
        if(old_dir)
        {
          if(old_dir[0] == old_dir_2[0])
            chdir(old_dir[0], &old_dir[1]);
          else
            chdir(old_dir_2[0], &old_dir[1]);
          getcwd(WORKING_DRIVE, &old_dir[1]);
        }
      }
      if(set_cwd(path, old_dir))
        retval = -1;
      else
        retval = getcwd(WORKING_DRIVE, index) - 1;
    }
  }
  else
  {
    pathptr = (char __near*)chg2filedir(path, old_dir_2);
    if(!error_code)
    {
      if(old_dir_2[0] != WORKING_DRIVE)
      {
        chdir(old_dir_2[0], &old_dir[1]);
        nmemcpy(&old_dir[1], &old_dir_2[1], (MAX_DIR_DEPTH+1)*sizeof(dirindex_t));
      }
      *index = get_file_index(WORKING_DRIVE, pathptr, old_dir);
      retval = 0;
    }
    else retval = -1;
  }
  SYMLINK_RECURSION_COUNT--;

  return retval;
}
