#include "globals.c"
#include "macros.c"
#include "structs.c"

unsigned long read_system_clock(void);
#pragma aux read_system_clock = \
  "push ax" \
  "xor ah, ah" \
  "int 0x1A" \
  "pop ax" \
  value [cx dx];

struct time htime(void)
{
  struct time retval;
  unsigned long system_ctr;
  signed long system_ctr2;
  unsigned minute;
  unsigned second;

  system_ctr = read_system_clock();

  for(retval.hour=0;
      (system_ctr2 = system_ctr - TICKS_PER_HOUR)>0;
      retval.hour++, system_ctr=system_ctr2);

//  retval.second = retval.minute = system_ctr;
  second = minute = system_ctr;

//  retval.minute /= TICKS_PER_MINUTE;
  minute /= TICKS_PER_MINUTE;

//  retval.second -= retval.minute * TICKS_PER_MINUTE;
  second -= minute * TICKS_PER_MINUTE;
//  retval.ssecond = retval.second % TICKS_PER_SECOND;
  retval.ssecond = second % TICKS_PER_SECOND;
//  retval.second /= TICKS_PER_SECOND;
  second /= TICKS_PER_SECOND;
  retval.ssecond *= 100 / TICKS_PER_SECOND;

/*  if(retval.second >= 60)
  {
    retval.minute++;
    retval.second -= 60;
  }*/
  if(second >= 60)
  {
    minute++;
    second -= 60;
  }
/*  if(retval.minute >= 60)
  {
    retval.hour++;
    retval.minute -= 60;
  }*/
  if(minute >= 60)
  {
    retval.hour++;
    minute -= 60;
  }

  retval.minute = minute;
  retval.second = second;

  return retval;
}
