#include <stdio.h>
#include <stdlib.h>

void show_help()
{
  puts("Usage: >SYS [TARGET] ([BOOTCODE])");
  puts("Where [TARGET] is either a file or a device");
  puts("If [BOOTCODE] is not specified, BOOTCODE.086 is used");
  puts("Example: >SYS DRV:A");

  exit(1);
}

int main(int argc, char *argv[])
{
  FILE *fp;
  FILE *bootcode;
  int c;
  char defbc[] = "BOOTCODE.086";
  char *bcfile;

  if(argc < 2)
    show_help();

  if(argc == 3)
    bcfile = argv[2];
  else
    bcfile = defbc;

  bootcode = fopen(bcfile, "rb");
  if(!bootcode)
  {
    puts("Cannot find BOOTCODE.086");
    return 1;
  }

  fp = fopen(argv[1], "rb+");
  if(!fp)
  {
    puts("Cannot open file");
    return 1;
  }

  // jmp
  fputc(0xE9, fp);
  fputc(0x21, fp);
  fputc(0, fp);

  fseek(fp, 0x24, SEEK_SET);
  while((c = fgetc(bootcode)) != EOF)
    fputc(c, fp);

  fclose(fp);
  fclose(bootcode);

  if(!errno)
    puts("Boot code transferred");


  return 0;
}
